import React from 'react'
import { Label } from 'react-bootstrap'
import { Tree } from '../src'

var nodes = [
  { 'nodeId': 1, 'name': 'Nucor-Yamato', 'nodeDetailTypeId': 1, 'nodeTypeId': 1, 'treeId': 1, 'parent': 0, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:44:25.292Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:44:25.292Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2, 'name': 'Administration', 'nodeDetailTypeId': 1, 'nodeTypeId': 2, 'treeId': 1, 'parent': 1, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:45:14.180Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:45:14.180Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 3, 'name': 'Environmental', 'nodeDetailTypeId': 1, 'nodeTypeId': 2, 'treeId': 1, 'parent': 1, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:45:47.272Z', 'modifiedBy': 1, 'modifiedDate': '2016-08-22T14:31:26.634Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 4, 'name': 'Maintenance', 'nodeDetailTypeId': 1, 'nodeTypeId': 2, 'treeId': 1, 'parent': 1, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:46:18.757Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:46:18.757Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 5, 'name': 'Melt Shop', 'nodeDetailTypeId': 1, 'nodeTypeId': 2, 'treeId': 1, 'parent': 1, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:46:28.315Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:46:28.315Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 6, 'name': 'Quality', 'nodeDetailTypeId': 1, 'nodeTypeId': 2, 'treeId': 1, 'parent': 1, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:46:35.987Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:46:35.987Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 7, 'name': 'Roll Mill', 'nodeDetailTypeId': 1, 'nodeTypeId': 2, 'treeId': 1, 'parent': 1, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:46:42.020Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:46:42.020Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 8, 'name': 'Sales', 'nodeDetailTypeId': 1, 'nodeTypeId': 2, 'treeId': 1, 'parent': 1, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:46:48.998Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:46:48.998Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 9, 'name': 'Shipping', 'nodeDetailTypeId': 1, 'nodeTypeId': 2, 'treeId': 1, 'parent': 1, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:46:55.131Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-25T20:21:14.293Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 10, 'name': '163A', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 4, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:47:23.493Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:47:23.493Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 11, 'name': '163D', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 4, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:47:37.602Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:47:37.602Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 12, 'name': '164A', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 4, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:47:45.659Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:47:45.659Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 13, 'name': '170A', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 4, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:47:53.331Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:47:53.331Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 14, 'name': '170B', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 4, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:48:01.161Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:48:01.161Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 15, 'name': '170C', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 4, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:48:09.318Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:48:09.318Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 16, 'name': '170D', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 4, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:48:17.282Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:48:17.282Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 17, 'name': '170E', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 4, 'rank': 8, 'ownerNodeId': 115, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:48:23.587Z', 'modifiedBy': 1, 'modifiedDate': '2016-09-22T22:27:20.182Z', 'userAccount': null, 'equipment': null, 'owner': { 'nodeId': 115, 'name': 'Maintenance Supervisor' } }, { 'nodeId': 18, 'name': '170F', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 4, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:48:30.033Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:48:30.033Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 19, 'name': '170G', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 4, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:48:37.151Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:48:37.151Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 20, 'name': '170H', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 4, 'rank': 11, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:48:45.175Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:48:45.175Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 21, 'name': '170I', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 4, 'rank': 12, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:48:55.347Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:48:55.347Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 22, 'name': '170J', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 4, 'rank': 13, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:49:02.975Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:49:02.975Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 23, 'name': '170K', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 4, 'rank': 14, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:49:16.206Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:49:16.206Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 24, 'name': '170L', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 4, 'rank': 15, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:49:25.622Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:49:25.622Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 25, 'name': '170M', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 4, 'rank': 16, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:49:33.631Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:49:33.631Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 26, 'name': '151E', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 5, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:50:06.677Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:50:06.677Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 27, 'name': '151A', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 5, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:50:13.463Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:50:13.463Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 28, 'name': '151B', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 5, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:50:23.392Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:50:23.392Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 29, 'name': '151C', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 5, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:50:31.656Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:50:31.656Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 30, 'name': '151D', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 5, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:50:37.696Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:50:37.696Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 31, 'name': '152E', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 5, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:50:47.325Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:50:47.325Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 32, 'name': '152A', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 5, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:50:54.230Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:50:54.230Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 33, 'name': '152B', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 5, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:51:03.520Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:51:03.520Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 34, 'name': '152C', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 5, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:51:14.149Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:51:14.149Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 35, 'name': '152D', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 5, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:51:21.683Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:51:21.683Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 36, 'name': '157A', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 5, 'rank': 11, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:51:29.996Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:51:29.996Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 37, 'name': '157B', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 5, 'rank': 12, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:51:35.049Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:51:35.049Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 38, 'name': '157C', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 5, 'rank': 13, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:51:42.395Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:51:42.395Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 39, 'name': '157D', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 5, 'rank': 14, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:51:48.915Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:51:48.915Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 40, 'name': '252E', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 5, 'rank': 15, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:52:02.261Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:52:02.261Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 41, 'name': '252A', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 5, 'rank': 16, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:52:08.951Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:52:08.951Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 42, 'name': '252B', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 5, 'rank': 17, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:52:14.707Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:52:14.707Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 43, 'name': '252C', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 5, 'rank': 18, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:52:19.868Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:52:19.868Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 44, 'name': '252D', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 5, 'rank': 19, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T18:52:24.658Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T18:52:24.658Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 45, 'name': '152G', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 5, 'rank': 20, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T19:09:36.817Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T19:09:36.817Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 46, 'name': '153A', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 7, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T19:11:11.714Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T19:11:11.714Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 47, 'name': '153B', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 7, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T19:11:17.889Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T19:11:17.889Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 48, 'name': '153C', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 7, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T19:11:23.742Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T19:11:23.742Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 49, 'name': '153D', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 7, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T19:11:35.202Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T19:11:35.202Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 50, 'name': '153X', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 7, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T19:11:43.370Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T19:11:43.370Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 51, 'name': '154A', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 7, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T19:11:58.140Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T19:11:58.140Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 52, 'name': '154B', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 7, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T19:12:05.088Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T19:12:05.088Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 53, 'name': '154C', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 7, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T19:12:13.517Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T19:12:13.517Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 54, 'name': '154D', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 7, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T19:12:21.169Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T19:12:21.169Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 55, 'name': '158A', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 7, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T19:12:37.857Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T19:12:37.857Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 56, 'name': '158B', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 7, 'rank': 11, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T19:12:43.995Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T19:12:43.995Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 57, 'name': '158C', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 7, 'rank': 12, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T19:12:51.330Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T19:12:51.330Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 58, 'name': '158D', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 7, 'rank': 13, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T19:12:56.806Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T19:12:56.806Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 59, 'name': '158X', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 7, 'rank': 14, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T19:13:08.945Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T19:13:08.945Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 60, 'name': '253A', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 7, 'rank': 15, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T19:13:27.514Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T19:13:27.514Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 61, 'name': '253B', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 7, 'rank': 16, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T19:13:34.993Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T19:13:34.993Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 62, 'name': '254A', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 7, 'rank': 17, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T19:13:40.853Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T19:13:40.853Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 63, 'name': '254B', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 7, 'rank': 18, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T19:13:46.368Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T19:13:46.368Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 64, 'name': '165E', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 3, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T19:31:11.150Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T19:31:11.150Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 65, 'name': '155Z', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 9, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:06:20.350Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:06:20.350Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 66, 'name': '155C', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 9, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:09:15.145Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:09:15.145Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 67, 'name': '155D', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 9, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:09:19.721Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:09:19.721Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 68, 'name': '155E', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 9, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:09:27.698Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:09:27.698Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 69, 'name': '155F', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 9, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:09:33.022Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:09:33.022Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 70, 'name': '155K', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 9, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:09:41.482Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:09:41.482Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 71, 'name': '155L', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 9, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:09:47.450Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:09:47.450Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 72, 'name': '155M', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 9, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:09:57.939Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:09:57.939Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 73, 'name': '155N', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 9, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:10:04.418Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:10:04.418Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 74, 'name': '155P', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 9, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:10:21.451Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:10:21.451Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 75, 'name': '155Q', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 9, 'rank': 11, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:10:31.848Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:10:31.848Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 76, 'name': '155X', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 9, 'rank': 12, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:10:53.914Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:10:53.914Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 77, 'name': '156A', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 9, 'rank': 13, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:11:04.210Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:11:04.210Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 78, 'name': '163B', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 9, 'rank': 14, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:11:22.474Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:11:22.474Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 79, 'name': '163E', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 9, 'rank': 15, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:11:30.954Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:11:30.954Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 80, 'name': '255G', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 9, 'rank': 16, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:11:44.495Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:11:44.495Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 81, 'name': '255H', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 9, 'rank': 17, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:11:49.486Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:11:49.486Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 82, 'name': '255I', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 9, 'rank': 18, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:12:01.608Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:12:01.608Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 83, 'name': '255J', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 9, 'rank': 19, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:12:08.331Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:12:08.331Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 84, 'name': '162A', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 6, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:19:26.702Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:19:26.702Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 85, 'name': '162B', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 6, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:19:37.303Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:19:37.303Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 86, 'name': '162C', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 6, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:19:42.651Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:19:42.651Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 87, 'name': '162D', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 6, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:19:49.528Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:19:49.528Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 88, 'name': '162E', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 6, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:19:58.110Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:19:58.110Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 89, 'name': '162G', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 6, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:20:04.612Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:20:04.612Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 90, 'name': 'Warehouse Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 10, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:51:25.644Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:51:25.644Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 92, 'name': 'Warehouse Clerk', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 10, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:59:42.340Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:59:42.340Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 93, 'name': 'Warehouse Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 10, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T20:59:58.360Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T20:59:58.360Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 98, 'name': 'Maintenance Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 11, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:01:23.967Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:01:23.967Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 99, 'name': 'Maintenance Clerk', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 11, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:01:35.460Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:01:35.460Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 100, 'name': 'Building & Grounds Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 11, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:01:44.817Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:01:44.817Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 101, 'name': 'Heavy Equipment Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 11, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:01:53.497Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:01:53.497Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 102, 'name': 'Maintenance Manager', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 12, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:02:13.436Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:02:13.436Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 103, 'name': 'Maintenance Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 12, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:02:20.691Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:03:21.546Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 104, 'name': 'Technical Manager', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 12, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:02:25.868Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-20T14:55:56.790Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 105, 'name': 'Maintenance Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 13, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:02:52.792Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:02:52.792Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 106, 'name': 'Day Electrical Support', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 13, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:03:03.759Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:03:03.759Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 107, 'name': 'Electrician', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 13, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:03:10.401Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:03:10.401Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 108, 'name': 'Maintenance Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 14, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:03:47.227Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:03:47.227Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 109, 'name': 'Mechanical Engineer', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 14, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:03:56.001Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:03:56.001Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 110, 'name': 'Maintenance Planner', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 14, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:04:05.836Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:04:05.836Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 111, 'name': 'Millwright', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 14, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:04:11.300Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:04:11.300Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 112, 'name': 'Lubricator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 14, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:04:17.608Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:04:17.608Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 113, 'name': 'Maintenance Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 15, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:04:28.357Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:04:28.357Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 114, 'name': 'Maintenance Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 16, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:04:32.678Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:04:32.678Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 115, 'name': 'Maintenance Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 17, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:04:36.743Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:04:36.743Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 116, 'name': 'Maintenance Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 18, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:04:40.835Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:04:40.835Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 117, 'name': 'Maintenance Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 19, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:04:43.282Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:04:43.282Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 118, 'name': 'Maintenance Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 20, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:04:50.496Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:04:50.496Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 119, 'name': 'Maintenance Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 21, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:04:53.050Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:04:53.050Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 120, 'name': 'Maintenance Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 22, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:04:59.184Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:04:59.184Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 121, 'name': 'Maintenance Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 23, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:05:03.645Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:05:03.645Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 122, 'name': 'Maintenance Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 24, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:05:05.826Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:05:05.826Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 123, 'name': 'Maintenance Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 25, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:05:07.972Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:05:07.972Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 124, 'name': 'Day Electrical Support', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 15, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:05:23.662Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:05:23.662Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 125, 'name': 'Day Electrical Support', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 17, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:05:40.255Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:05:40.255Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 126, 'name': 'Maintenance Planner', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 19, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:05:47.990Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:07:50.353Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 127, 'name': 'Electrician', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 15, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:06:00.991Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:06:00.991Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 128, 'name': 'Maintenance Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 16, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:06:13.909Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:06:13.909Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 129, 'name': 'Mechanical Apprentice', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 16, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:06:22.368Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-20T18:29:10.878Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 130, 'name': 'Lube Coordinator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 16, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:06:29.781Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:06:29.781Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 131, 'name': 'Millwright', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 16, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:06:35.631Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:06:35.631Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 132, 'name': 'Mechanic', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 16, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:06:41.268Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:06:41.268Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 133, 'name': 'Fabricator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 16, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:06:49.983Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:06:49.983Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 134, 'name': 'Machinist', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 16, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:06:55.066Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:06:55.066Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 136, 'name': 'Day Mechanical Support', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 18, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:07:09.525Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:07:09.525Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 137, 'name': 'Mechanical Engineer', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 18, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:07:16.339Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:07:16.339Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 138, 'name': 'Millwright', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 18, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:07:21.559Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:07:21.559Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 139, 'name': 'Day Electrical Support', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 19, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:07:33.206Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:07:33.206Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 140, 'name': 'Electrician', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 19, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:07:57.609Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:07:57.609Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 141, 'name': 'Electrical Apprentice', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 20, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:08:10.320Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:08:10.320Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 142, 'name': 'Electrician', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 20, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:08:19.112Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:08:19.112Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 143, 'name': 'Millwright', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 20, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:08:26.443Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:08:26.443Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 144, 'name': 'Lubricator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 20, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:08:32.887Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:08:32.887Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 145, 'name': 'Maintenance Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 21, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:08:42.655Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:08:42.655Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 146, 'name': 'Electrical Engineer', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 21, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:08:49.623Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:08:49.623Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 147, 'name': 'HVAC Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 21, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:08:54.360Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-20T18:54:23.330Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 148, 'name': 'Electrician', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 21, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:09:00.348Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:09:00.348Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 149, 'name': 'Day Mechanical Support', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 22, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:09:07.145Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:09:07.145Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 150, 'name': 'Mobile Mechanic', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 22, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:09:14.435Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:09:14.435Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 151, 'name': 'Mobile Planner', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 22, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:09:20.930Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:09:20.930Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 152, 'name': 'Maintenance Planner', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 23, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:09:34.783Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:09:34.783Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 153, 'name': 'Maintenance Apprentice', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 23, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:09:43.936Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:09:43.936Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 154, 'name': 'Lubricator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 23, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:09:51.514Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:09:51.514Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 155, 'name': 'Millwright', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 23, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:09:56.253Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:09:56.253Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 156, 'name': 'Maintenance Planner', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 24, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:10:26.579Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:10:26.579Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 157, 'name': 'Lubricator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 24, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:10:37.669Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:10:37.669Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 158, 'name': 'Millwright', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 24, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:10:44.510Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:10:44.510Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 159, 'name': 'Leadman', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 25, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:10:58.415Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:10:58.415Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 160, 'name': 'Millwright', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 25, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-12T21:11:04.279Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-12T21:11:04.279Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 286, 'name': 'Environmental Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 64, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-13T19:36:15.619Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-13T19:36:15.619Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 287, 'name': 'Environmental Coordinator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 64, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-13T19:36:26.562Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-13T19:36:26.562Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 288, 'name': 'Environmental Engineer', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 64, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-13T19:36:43.995Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-13T19:36:43.995Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 289, 'name': 'Environmental Tech', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 64, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-13T19:36:51.031Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-13T19:36:51.031Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 290, 'name': 'Radiation Tech', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 64, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-13T19:36:59.351Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-13T19:36:59.351Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 291, 'name': 'Baghouse Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 64, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-13T19:37:07.851Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-13T19:37:07.851Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 292, 'name': '161', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 8, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-14T19:07:17.122Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-14T19:07:17.122Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 293, 'name': '161A', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 8, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-14T19:07:23.075Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-14T19:07:23.075Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 294, 'name': '161B', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 8, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-14T19:07:28.365Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-14T19:07:28.365Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 295, 'name': '161C', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 8, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-14T19:07:32.231Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-14T19:07:32.231Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 296, 'name': 'Sales Manager', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 292, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-14T19:07:45.191Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-14T19:07:45.191Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 715, 'name': 'Melting Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 26, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:16:39.005Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:16:39.005Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 716, 'name': 'Furnace Refractory Coordinator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 26, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:19:10.846Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:19:10.846Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 717, 'name': 'Alloy Material Handler', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 26, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:20:26.461Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:20:26.461Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 718, 'name': 'Refractory Lead Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 26, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:20:51.959Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:20:51.959Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 719, 'name': 'Melting Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 27, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:24:47.571Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:24:47.571Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 720, 'name': 'First Helper', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 27, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:25:09.289Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:25:09.289Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 721, 'name': 'EAF Helper', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 27, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:25:17.260Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:25:17.260Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 722, 'name': '#1 Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 27, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:25:33.112Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:25:33.112Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 723, 'name': '#2 Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 27, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:25:44.930Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:25:44.930Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 724, 'name': 'Melting Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 28, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:25:56.965Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:25:56.965Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 725, 'name': 'First Helper', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 28, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:26:03.823Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:26:03.823Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 726, 'name': 'EAF Helper', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 28, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:26:10.001Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:26:10.001Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 727, 'name': '#1 Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 28, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:26:20.144Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:26:20.144Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 728, 'name': '#2 Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 28, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:26:37.745Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:26:37.745Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 729, 'name': 'Melting Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 29, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:27:02.285Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:27:02.285Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 730, 'name': 'First Helper', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 29, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:27:07.257Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:27:07.257Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 731, 'name': 'EAF Helper', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 29, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:27:12.339Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:27:12.339Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 732, 'name': '#1 Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 29, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:27:26.825Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:27:26.825Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 733, 'name': '#2 Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 29, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:27:33.872Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:27:33.872Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 734, 'name': 'Komatsu Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 27, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:27:46.260Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:27:46.260Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 735, 'name': 'Komatsu Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 28, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:27:53.579Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:27:53.579Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 736, 'name': 'Komatsu Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 29, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:28:09.920Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:28:09.920Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 737, 'name': 'Melting Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 30, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:28:22.116Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:28:22.116Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 738, 'name': 'First Helper', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 30, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:28:26.827Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:28:26.827Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 739, 'name': 'EAF Helper', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 30, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:28:31.415Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:28:31.415Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 740, 'name': '#1 Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 30, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:28:38.886Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:28:38.886Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 741, 'name': '#2 Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 30, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:28:46.506Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:28:46.506Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 742, 'name': 'Komatsu Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 30, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:28:52.934Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:28:52.934Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 743, 'name': 'Caster Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 31, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:29:10.708Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:29:10.708Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 744, 'name': 'Yard', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 31, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:30:00.527Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:30:00.527Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 745, 'name': 'EAF Analytical Tech', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 31, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:30:21.747Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:30:21.747Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 746, 'name': 'Caster Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 32, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:30:49.348Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:30:49.348Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 747, 'name': 'Caster Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 32, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:30:56.425Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:30:56.425Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 748, 'name': 'Torch Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 32, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:31:03.367Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:31:03.367Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 749, 'name': 'Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 32, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:31:09.000Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:31:09.000Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 750, 'name': 'LMF Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 32, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:31:16.350Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:31:16.350Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 751, 'name': 'Ladle Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 32, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:31:22.531Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:31:22.531Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 752, 'name': 'LMF/Ladle Person Assistant', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 32, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:31:44.390Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:31:44.390Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 753, 'name': '#36 Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 32, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:32:00.800Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:32:00.800Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 754, 'name': 'Bloom Yard Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 32, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:32:42.098Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:32:42.098Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 755, 'name': 'Caster Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 33, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:32:56.975Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:32:56.975Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 756, 'name': 'Caster Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 33, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:33:05.333Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:33:05.333Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 757, 'name': 'Torch Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 33, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:33:15.704Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:33:15.704Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 758, 'name': 'Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 33, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:33:24.187Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:33:24.187Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 759, 'name': 'LMF Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 33, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:33:31.123Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:33:31.123Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 760, 'name': 'Ladle Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 33, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:33:37.117Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:33:45.800Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 761, 'name': 'LMF/Ladle Person Assistant', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 33, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:34:05.409Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:34:05.409Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 762, 'name': '#36 Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 33, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:34:15.008Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:34:15.008Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 763, 'name': 'Bloom Yard Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 33, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:34:21.757Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:34:21.757Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 764, 'name': 'Caster Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 34, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:35:44.189Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:35:44.189Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 765, 'name': 'Caster Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 34, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:35:55.961Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:35:55.961Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 766, 'name': 'Torch Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 34, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:36:03.750Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:36:03.750Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 767, 'name': 'Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 34, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:36:11.280Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:36:11.280Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 768, 'name': 'LMF Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 34, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:36:18.728Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:36:18.728Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 769, 'name': 'Ladle Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 34, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:36:23.811Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:36:23.811Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 770, 'name': 'LMF/Ladle Person Assistant', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 34, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:36:36.504Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:36:36.504Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 771, 'name': '#36 Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 34, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:36:43.655Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:36:43.655Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 772, 'name': 'Bloom Yard Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 34, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:36:55.861Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:36:55.861Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 773, 'name': 'Caster Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 35, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:37:53.104Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:37:53.104Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 774, 'name': 'Caster Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 35, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:37:59.719Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:37:59.719Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 775, 'name': 'Torch Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 35, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:38:05.381Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:38:05.381Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 776, 'name': 'Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 35, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:38:13.927Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:38:13.927Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 777, 'name': 'LMF Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 35, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:38:36.444Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:38:36.444Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 778, 'name': 'Ladle Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 35, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:38:41.407Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:38:41.407Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 779, 'name': 'LMF/Ladle Person Assistant', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 35, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:38:50.550Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:38:50.550Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 780, 'name': '#36 Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 35, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:38:59.131Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:38:59.131Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 781, 'name': 'Bloom Yard Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 35, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T13:39:09.096Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T13:39:09.096Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 782, 'name': 'Refractory', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 36, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:17:32.711Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:17:32.711Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 783, 'name': 'Bricker', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 36, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:17:41.566Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:17:41.566Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 784, 'name': 'Refractory', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 37, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:23:49.260Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:23:49.260Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 785, 'name': 'Bricker', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 37, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:23:53.562Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:23:53.562Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 786, 'name': 'Refractory', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 38, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:24:02.757Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:24:02.757Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 787, 'name': 'Bricker', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 38, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:24:04.806Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:24:04.806Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 788, 'name': 'Refractory', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 39, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:24:13.120Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:24:13.120Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 789, 'name': 'Bricker', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 39, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:24:15.040Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:24:15.040Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 790, 'name': 'Caster Supervior', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 40, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:24:32.933Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:24:32.933Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 791, 'name': 'Caster Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 41, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:24:52.829Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:24:52.829Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 792, 'name': 'Caster Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 41, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:24:58.269Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:24:58.269Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 793, 'name': 'Torch Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 41, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:25:06.471Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:25:06.471Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 794, 'name': 'Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 41, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:25:11.677Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:25:27.646Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 795, 'name': 'LMF Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 41, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:26:09.578Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:26:09.578Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 796, 'name': 'Ladle Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 41, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:26:13.779Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:26:13.779Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 797, 'name': 'LMF/Ladle Person Assistant', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 41, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:26:21.333Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:26:21.333Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 798, 'name': '#23 Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 41, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:26:29.817Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-25T15:23:49.982Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 799, 'name': 'Bloom Yard Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 41, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:26:36.752Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:26:36.752Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 800, 'name': 'Caster Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 42, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:26:56.911Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:26:56.911Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 801, 'name': 'Caster Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 42, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:27:04.681Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:27:04.681Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 802, 'name': 'Torch Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 42, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:27:14.734Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:27:14.734Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 803, 'name': 'Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 42, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:27:18.761Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:27:18.761Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 804, 'name': 'LMF Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 42, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:27:24.124Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:27:24.124Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 805, 'name': 'Ladle Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 42, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:27:30.637Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:27:30.637Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 806, 'name': 'LMF/Ladle Person Assistant', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 42, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:27:39.059Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:27:39.059Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 807, 'name': '#23 Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 42, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:27:45.213Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-25T15:45:20.474Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 808, 'name': 'Bloom Yard Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 42, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:27:54.120Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:27:54.120Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 809, 'name': 'Caster Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 43, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:29:34.700Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:29:34.700Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 810, 'name': 'Caster Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 43, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:29:40.641Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:29:40.641Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 811, 'name': 'Torch Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 43, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:29:52.648Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:29:52.648Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 812, 'name': 'Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 43, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:29:57.503Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:29:57.503Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 813, 'name': 'LMF Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 43, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:30:02.885Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:30:02.885Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 814, 'name': 'Ladle Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 43, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:30:07.523Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:30:07.523Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 815, 'name': 'LMF/Ladle Person Assistant', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 43, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:30:17.867Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:30:17.867Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 816, 'name': '#23 Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 43, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:30:29.490Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-25T15:49:18.556Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 817, 'name': 'Bloom Yard Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 43, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:30:35.738Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:30:35.738Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 818, 'name': 'Caster Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 44, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:32:18.000Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:32:18.000Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 819, 'name': 'Caster Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 44, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:32:21.831Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:32:21.831Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 820, 'name': 'Torch Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 44, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:32:27.274Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:32:27.274Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 821, 'name': 'Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 44, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:32:30.442Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:32:30.442Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 822, 'name': 'LMF Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 44, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:32:38.164Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:32:38.164Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 823, 'name': 'Ladle Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 44, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:32:43.021Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:32:43.021Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 824, 'name': 'LMF/Ladle Person Assistant', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 44, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:33:59.217Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:33:59.217Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 825, 'name': '#23 Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 44, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:34:17.962Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-25T15:51:11.990Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 826, 'name': 'Bloom Yard Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 44, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:34:25.438Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:34:25.438Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 827, 'name': 'Melt Shop Scheduler', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 45, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:37:00.325Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:37:00.325Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 828, 'name': 'Melt Shop Clerk', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 45, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T14:37:06.301Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T14:37:06.301Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 829, 'name': 'Roll Mill Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 46, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:12:14.155Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:12:14.155Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 830, 'name': 'Roll Mill Lead Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 46, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:12:21.870Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:12:21.870Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 831, 'name': 'Reheat Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 46, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:12:27.967Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:12:27.967Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 832, 'name': 'Utility Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 46, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:12:33.169Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:12:33.169Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 833, 'name': 'Mill Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 46, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:12:39.603Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:12:39.603Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 834, 'name': 'Sample Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 46, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:12:50.161Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:12:50.161Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 835, 'name': 'Roll Mill Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 47, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:13:06.532Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:13:06.532Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 836, 'name': 'Roll Mill Lead Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 47, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:13:13.265Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:13:13.265Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 837, 'name': 'Reheat Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 47, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:13:26.068Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:13:26.068Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 838, 'name': 'Utility Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 47, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:14:14.890Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:14:14.890Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 839, 'name': 'Mill Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 47, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:14:18.961Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:14:18.961Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 840, 'name': 'Sample Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 47, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:14:26.629Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:14:26.629Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 841, 'name': 'Roll Mill Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 48, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:14:44.585Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:14:44.585Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 842, 'name': 'Roll Mill Lead Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 48, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:14:50.075Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:14:50.075Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 843, 'name': 'Reheat Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 48, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:15:03.317Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:15:03.317Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 844, 'name': 'Utility Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 48, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:15:08.037Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:15:08.037Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 845, 'name': 'Mill Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 48, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:15:13.130Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:15:13.130Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 846, 'name': 'Sample Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 48, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:15:19.465Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:15:19.465Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 847, 'name': 'Roll Mill Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 49, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:15:40.781Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:15:40.781Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 848, 'name': 'Roll Mill Lead Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 49, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:15:51.441Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:15:51.441Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 849, 'name': 'Reheat Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 49, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:16:05.242Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:16:05.242Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 850, 'name': 'Utility Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 49, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:16:13.629Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:16:13.629Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 851, 'name': 'Mill Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 49, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:16:18.079Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:16:18.079Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 852, 'name': 'Sample Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 49, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:16:23.162Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:16:23.162Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 853, 'name': 'Roll Mill Lead Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 50, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:16:40.367Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-20T20:43:11.065Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 854, 'name': 'Roll Mill Engineer', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 50, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:16:46.500Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:16:46.500Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 855, 'name': 'Roll Mill Scheduler', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 50, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:16:53.374Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:16:53.374Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 857, 'name': 'Roll Shop Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 50, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:17:13.631Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:17:13.631Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 858, 'name': 'Roll Designer', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 50, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:17:19.535Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:17:19.535Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 859, 'name': 'Finishing Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 51, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:19:37.523Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:19:37.523Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 860, 'name': 'Finishing Lead Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 51, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:19:42.890Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:19:42.890Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 861, 'name': 'Hot Saw Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 51, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:19:48.845Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:19:48.845Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 862, 'name': 'Cooling Bed Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 51, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:20:04.739Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:20:04.739Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 863, 'name': 'Straightener Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 51, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:20:12.347Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:20:12.347Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 864, 'name': 'Cold Saw Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 51, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:20:17.820Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:20:17.820Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 865, 'name': 'Cold Saw Recorder', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 51, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:20:25.636Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:20:25.636Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 866, 'name': 'Inspection Bed Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 51, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:20:35.222Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:20:35.222Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 867, 'name': 'Inspection Bed Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 51, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:20:44.166Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:20:44.166Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 868, 'name': 'Utility Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 51, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:20:49.817Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:20:49.817Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 869, 'name': 'Repair Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 51, 'rank': 11, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:20:57.650Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:20:57.650Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 870, 'name': 'Piler Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 51, 'rank': 12, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:21:08.968Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:21:08.968Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 871, 'name': 'Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 51, 'rank': 13, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:21:15.241Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:21:15.241Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 872, 'name': 'Finishing Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 52, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:21:45.699Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:21:45.699Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 873, 'name': 'Finishing Lead Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 52, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:21:52.977Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:21:52.977Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 874, 'name': 'Hot Saw Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 52, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:21:58.831Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:21:58.831Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 875, 'name': 'Cooling Bed Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 52, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:22:07.834Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:22:07.834Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 876, 'name': 'Straightener Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 52, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:22:29.319Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:22:29.319Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 877, 'name': 'Cold Saw Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 52, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:22:50.309Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:22:50.309Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 878, 'name': 'Cold Saw Recorder', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 52, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:22:54.424Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:22:54.424Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 879, 'name': 'Inspection Bed Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 52, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:23:05.397Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:23:05.397Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 880, 'name': 'Inspection Bed Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 52, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:23:23.905Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:23:23.905Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 881, 'name': 'Utility Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 52, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:23:30.664Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:23:30.664Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 882, 'name': 'Repair Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 52, 'rank': 11, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:23:36.484Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:23:36.484Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 883, 'name': 'Piler Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 52, 'rank': 12, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:23:41.901Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:23:41.901Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 884, 'name': 'Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 52, 'rank': 13, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:23:54.122Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:23:54.122Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 885, 'name': 'Finishing Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 53, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:24:20.450Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:24:20.450Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 886, 'name': 'Finishing Lead Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 53, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:24:24.548Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:24:24.548Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 887, 'name': 'Hot Saw Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 53, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:24:28.860Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:24:28.860Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 888, 'name': 'Cooling Bed Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 53, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:24:39.032Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:24:39.032Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 889, 'name': 'Straightener Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 53, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:24:51.801Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:24:51.801Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 890, 'name': 'Cold Saw Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 53, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:24:57.569Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:24:57.569Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 891, 'name': 'Cold Saw Recorder', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 53, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:25:02.728Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:25:02.728Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 892, 'name': 'Inspection Bed Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 53, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:25:17.742Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:25:17.742Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 893, 'name': 'Inspection Bed Insepctor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 53, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:25:26.550Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:25:26.550Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 894, 'name': 'Utility Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 53, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:25:31.923Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:25:31.923Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 895, 'name': 'Repair Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 53, 'rank': 11, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:25:40.070Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:25:40.070Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 896, 'name': 'Piler Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 53, 'rank': 12, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:25:49.236Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:25:49.236Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 897, 'name': 'Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 53, 'rank': 13, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:25:57.299Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:25:57.299Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 898, 'name': 'Finishing Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 54, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:26:34.075Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:26:34.075Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 899, 'name': 'Finishing Lead Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 54, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:26:42.128Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:26:42.128Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 900, 'name': 'Hot Saw Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 54, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:26:47.606Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:26:47.606Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 901, 'name': 'Cooling Bed Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 54, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:26:54.006Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:26:54.006Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 902, 'name': 'Straightener Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 54, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:27:02.703Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:27:02.703Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 903, 'name': 'Cold Saw Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 54, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:27:08.130Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:27:08.130Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 904, 'name': 'Cold Saw Recorder', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 54, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:27:13.084Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:27:13.084Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 905, 'name': 'Inspection Bed Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 54, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:27:21.247Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:27:21.247Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 906, 'name': 'Inspection Bed Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 54, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:27:28.133Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:27:28.133Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 907, 'name': 'Utility Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 54, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:27:35.948Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:27:35.948Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 908, 'name': 'Repair Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 54, 'rank': 11, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:27:40.938Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:27:40.938Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 909, 'name': 'Piler Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 54, 'rank': 12, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:27:45.603Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:27:45.603Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 910, 'name': 'Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 54, 'rank': 13, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:27:52.238Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:27:52.238Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 911, 'name': 'Roll Shop Fabricator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 55, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:28:34.441Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:28:34.441Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 912, 'name': 'Roll Shop Machinist', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 55, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:28:41.796Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:28:41.796Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 913, 'name': 'Stand Builder', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 55, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:28:46.062Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:28:46.062Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 914, 'name': 'Lathe Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 56, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:28:53.471Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:28:53.471Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 915, 'name': 'Roll Turner', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 56, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:28:57.217Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:28:57.217Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 916, 'name': 'Roll Shop Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 57, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:29:06.476Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:29:06.476Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 917, 'name': 'Roll Shop Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 57, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:29:12.008Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-20T21:07:37.731Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 918, 'name': 'Lathe Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 57, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:29:20.580Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:29:20.580Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 919, 'name': 'Roll Shop Fabricator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 57, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:29:26.980Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:29:26.980Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 920, 'name': 'Roll Turner', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 57, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:29:30.545Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:29:30.545Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 921, 'name': 'Roll Guide Builder', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 57, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:29:34.360Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:29:34.360Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 922, 'name': 'Saw Sharpener', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 57, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:29:39.609Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:29:39.609Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 923, 'name': 'Roll Shop Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 58, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:29:58.631Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-20T21:09:30.625Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 924, 'name': 'Guide Builder', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 58, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:30:03.283Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:30:03.283Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 925, 'name': 'Roll Shop Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 59, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:30:10.801Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:30:10.801Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 926, 'name': 'Roll Shop Technician', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 59, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:30:18.424Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:30:25.850Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 927, 'name': 'Roll Mill Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 60, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:30:42.240Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:30:42.240Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 928, 'name': 'Roll Mill Lead Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 60, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:30:47.690Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:30:47.690Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 929, 'name': 'Reheat Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 60, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:30:52.211Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:30:52.211Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 930, 'name': 'Crane Utility', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 60, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:30:56.196Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:30:56.196Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 931, 'name': 'Utility Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 60, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:31:00.566Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:31:00.566Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 932, 'name': 'Mill Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 60, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:31:08.198Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:31:08.198Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 933, 'name': 'Hot Saw Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 60, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:31:13.713Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:31:13.713Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 934, 'name': 'Cooling Bed Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 60, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:31:20.439Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:31:20.439Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 935, 'name': 'Sample Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 60, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:31:30.211Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:31:30.211Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 936, 'name': 'Roll Mill Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 61, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:31:38.622Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:31:38.622Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 937, 'name': 'Roll Mill Lead Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 61, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:31:43.506Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:31:43.506Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 938, 'name': 'Reheat Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 61, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:31:47.254Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:31:47.254Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 939, 'name': 'Crane Utility', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 61, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:31:50.949Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:31:50.949Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 940, 'name': 'Mill Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 61, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:31:54.622Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:31:54.622Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 941, 'name': 'Hot Saw Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 61, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:32:02.136Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:32:02.136Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 942, 'name': 'Cooling Bed Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 61, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:32:09.510Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:32:09.510Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 943, 'name': 'Sample Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 61, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:32:15.561Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:32:15.561Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 944, 'name': 'Finishing Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 62, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:32:26.972Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:32:26.972Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 945, 'name': 'Finishing Lead Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 62, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:32:31.483Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:32:31.483Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 946, 'name': 'Crew Recorder', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 62, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:32:34.393Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:32:34.393Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 947, 'name': 'Inspection Bed Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 62, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:32:42.380Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:32:42.380Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 948, 'name': 'Inspection Bed Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 62, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:32:48.279Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:32:48.279Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 949, 'name': 'Cooling Bed Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 62, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:32:55.176Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:32:55.176Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 950, 'name': 'Piler Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 62, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:32:58.929Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:32:58.929Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 951, 'name': 'Relief Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 62, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:33:03.005Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:33:03.005Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 952, 'name': 'Straightener Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 62, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:33:09.890Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:33:09.890Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 953, 'name': 'Repair Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 62, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:33:14.227Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:33:14.227Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 954, 'name': 'Repair Person Helper', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 62, 'rank': 11, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:33:20.675Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:33:20.675Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 955, 'name': 'Finishing Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 63, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:33:30.141Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:33:30.141Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 956, 'name': 'Finishing Lead Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 63, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:33:34.412Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:33:34.412Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 957, 'name': 'Crew Recorder', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 63, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:33:38.797Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:33:38.797Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 958, 'name': 'Inspection Bed Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 63, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:33:43.326Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:33:43.326Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 959, 'name': 'Inspection Bed Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 63, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:33:47.766Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:33:47.766Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 960, 'name': 'Cooling Bed Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 63, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:33:53.897Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:33:53.897Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 961, 'name': 'Piler Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 63, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:33:57.815Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:33:57.815Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 962, 'name': 'Relief Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 63, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:34:02.126Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:34:02.126Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 963, 'name': 'Straightener Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 63, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:34:09.835Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:34:09.835Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 964, 'name': 'Repair Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 63, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:34:14.135Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:34:14.135Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 965, 'name': 'Repair Person Helper', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 63, 'rank': 11, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:34:19.239Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:34:19.239Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 966, 'name': '160', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 2, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:34:54.938Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:34:54.938Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 967, 'name': '160A', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 2, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:34:58.807Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:34:58.807Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 968, 'name': '160B', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 2, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:35:05.483Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:35:05.483Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 969, 'name': '160C', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 2, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:35:08.746Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:35:08.746Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 970, 'name': '163C', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 2, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:35:38.984Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:35:38.984Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 971, 'name': '163F', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 2, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:35:52.134Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:35:52.134Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 972, 'name': '163G', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 2, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:35:55.599Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:35:55.599Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 973, 'name': '163H', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 2, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:36:00.969Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:36:00.969Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 974, 'name': '163I', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 2, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:36:04.399Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:36:04.399Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 975, 'name': '163J', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 2, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:36:15.050Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:36:15.050Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 976, 'name': '163K', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 2, 'rank': 11, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:36:17.081Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:36:17.081Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 977, 'name': 'General Manager', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 966, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:36:46.840Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:36:46.840Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 978, 'name': 'Controller', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 966, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:36:58.173Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:36:58.173Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 979, 'name': 'Financial Analyst', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 967, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:38:06.279Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:38:06.279Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 980, 'name': 'Accountant', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 968, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:38:15.431Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:43:00.231Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 981, 'name': 'Accounts Payable Clerk', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 968, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:38:25.023Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:43:08.416Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 982, 'name': 'Receptionist', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 968, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:38:32.372Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:38:32.372Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 984, 'name': 'Credit Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 969, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:38:56.011Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:38:56.011Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 985, 'name': 'Credit Analyst', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 969, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:40:23.910Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:40:23.910Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 986, 'name': 'Credit Clerk', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 969, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:40:29.613Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:40:29.613Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 987, 'name': 'Lead Systems Analyst', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 970, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:40:42.303Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:40:42.303Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 988, 'name': 'Systems Analyst', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 970, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:40:51.428Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:43:22.603Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 989, 'name': 'Purchasing Agent', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 971, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:41:15.309Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:41:15.309Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 990, 'name': 'Buyer', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 971, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:41:17.405Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:41:17.405Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 991, 'name': 'Human Resources Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 972, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:41:39.090Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:41:39.090Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 992, 'name': 'HR/Payroll Administrator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 972, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:41:57.750Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:41:57.750Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 993, 'name': 'Human Resources Clerk', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 972, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:42:08.310Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:42:08.310Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 994, 'name': 'Network Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 973, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:42:39.555Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:43:45.528Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 995, 'name': 'PC Tech', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 973, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:42:45.602Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:42:45.602Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 996, 'name': 'Systems Analyst', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 973, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:43:58.119Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:43:58.119Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 997, 'name': 'Safety Director', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 974, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:44:15.675Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:44:15.675Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 998, 'name': 'Nurse', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 974, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:44:19.308Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:44:19.308Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 999, 'name': 'Safety Coordinator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 974, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:44:25.568Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:44:25.568Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1000, 'name': 'Health and Safety Administrator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 974, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:44:42.819Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:44:42.819Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1001, 'name': 'Business Process Analyst', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 975, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:44:53.791Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:44:53.791Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1002, 'name': 'Lead Analyst', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 975, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:45:00.368Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:45:00.368Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1003, 'name': 'Systems Analyst', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 975, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:45:06.397Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:45:06.397Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1004, 'name': 'Lead Business Process Analyst', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 976, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:45:23.799Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:45:23.799Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1005, 'name': 'Business Process Analyst', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 976, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:45:36.240Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:45:36.240Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1006, 'name': '163P', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 2, 'rank': 12, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:45:47.457Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:45:47.457Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1007, 'name': 'IT Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 1006, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:46:06.419Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:46:06.419Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1008, 'name': '162', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 6, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:47:39.071Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:47:39.071Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1009, 'name': 'Lead Lab Tech', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 84, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:48:42.542Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:48:42.542Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1010, 'name': 'Lab Tech', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 84, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:48:46.685Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:48:46.685Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1011, 'name': 'Lead Lab Tech', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 85, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:49:03.763Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:49:03.763Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1012, 'name': 'Lab Tech', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 85, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:49:06.606Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:49:06.606Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1013, 'name': 'Lead Lab Tech', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 86, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:49:13.570Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:49:13.570Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1014, 'name': 'Lab Tech', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 86, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:49:17.800Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:49:17.800Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1015, 'name': 'Lead Lab Tech', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 87, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:49:23.069Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:49:23.069Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1016, 'name': 'Lab Tech', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 87, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:49:25.806Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:49:25.806Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1017, 'name': 'ISO Coordinator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 88, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:49:53.831Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:49:53.831Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1018, 'name': 'Quality Clerk', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 88, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:49:59.409Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:49:59.409Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1019, 'name': 'Metallurgist', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 88, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:50:04.473Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:50:04.473Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1020, 'name': 'NDT Tech', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 89, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:50:16.961Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:50:16.961Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1021, 'name': 'Metallurgist', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 89, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:50:25.480Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:50:25.480Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1022, 'name': 'Chief Metallurgist', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 1008, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:50:39.776Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:50:39.776Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1023, 'name': 'Inside Sales Rep', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 293, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:51:33.785Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:51:33.785Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1024, 'name': 'Outside Sales Rep', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 294, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:51:48.057Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:51:48.057Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1025, 'name': 'Sales Coordinator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 295, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:51:55.593Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:51:55.593Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1026, 'name': 'Outside Sales Rep', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 295, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:52:04.772Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:52:04.772Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1027, 'name': '155', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 9, 'rank': 20, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:54:27.563Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:54:27.563Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1028, 'name': 'Shipping Manager', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 1027, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:55:22.145Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:55:22.145Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1029, 'name': 'Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 65, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:55:31.343Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:55:31.343Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1030, 'name': 'Assistant Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 66, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:56:30.530Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:56:30.530Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1031, 'name': 'Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 66, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:56:33.907Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:56:33.907Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1032, 'name': 'Shipper Loader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 66, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:56:39.360Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:56:39.360Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1033, 'name': 'Shuttle Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 66, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:56:47.291Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:58:15.642Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1034, 'name': 'Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 66, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:57:06.383Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:57:06.383Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1035, 'name': 'Assistant Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 67, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:57:20.084Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:57:20.084Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1036, 'name': 'Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 67, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:57:27.361Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:57:27.361Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1037, 'name': 'Shipper Loader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 67, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:57:48.884Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:57:48.884Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1038, 'name': 'Shuttle Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 67, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:58:01.247Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:58:01.247Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1039, 'name': 'Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 67, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:58:06.469Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:58:06.469Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1040, 'name': 'Assistant Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 68, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:58:36.924Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:58:36.924Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1041, 'name': 'Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 68, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:58:40.462Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:58:40.462Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1042, 'name': 'Shipper Loader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 68, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:58:44.749Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:58:44.749Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1043, 'name': 'Shuttle Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 68, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:58:48.425Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:58:48.425Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1044, 'name': 'Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 68, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:58:51.177Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:58:51.177Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1045, 'name': 'Assistant Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 69, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:59:04.806Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:59:04.806Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1046, 'name': 'Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 69, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:59:07.656Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:59:07.656Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1047, 'name': 'Shipper Loader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 69, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:59:10.145Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:59:10.145Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1048, 'name': 'Shuttle Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 69, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:59:14.917Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:59:14.917Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1049, 'name': 'Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 69, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:59:17.791Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:59:17.791Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1050, 'name': 'Assistant Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 70, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:59:32.767Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:59:32.767Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1051, 'name': 'Taylor Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 70, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:59:36.600Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:59:36.600Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1052, 'name': 'Hem Saw-Random', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 70, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:59:50.331Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:59:50.331Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1053, 'name': 'Shuttle Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 70, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:59:55.352Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:59:55.352Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1054, 'name': 'Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 70, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T15:59:58.235Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T15:59:58.235Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1055, 'name': 'Assistant Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 71, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:00:16.921Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:00:16.921Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1056, 'name': 'Taylor Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 71, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:00:20.016Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:00:20.016Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1057, 'name': 'Hem Saw-Random', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 71, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:00:24.787Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:00:24.787Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1058, 'name': 'Shuttle Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 71, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:00:27.691Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:00:27.691Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1059, 'name': 'Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 71, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:00:30.723Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:00:30.723Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1060, 'name': 'Assistant Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 72, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:00:38.734Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:00:38.734Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1061, 'name': 'Taylor Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 72, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:00:42.391Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:00:42.391Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1062, 'name': 'Hem Saw-Random', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 72, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:00:46.746Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:00:46.746Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1063, 'name': 'Shuttle Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 72, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:00:50.340Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:00:50.340Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1064, 'name': 'Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 72, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:00:55.804Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:00:55.804Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1065, 'name': 'Assistant Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 73, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:01:14.760Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:01:14.760Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1066, 'name': 'Taylor Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 73, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:01:20.057Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:01:20.057Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1067, 'name': 'Hem Saw-Random', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 73, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:01:24.159Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:01:24.159Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1068, 'name': 'Shuttle Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 73, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:01:30.008Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:01:30.008Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1069, 'name': 'Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 73, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:01:32.406Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:01:32.406Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1070, 'name': 'Assistant Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 74, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:01:46.750Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:01:46.750Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1071, 'name': 'Shipper Loader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 74, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:01:51.298Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:01:51.298Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1072, 'name': 'Lead Mechanic', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 75, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:02:05.430Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:02:05.430Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1073, 'name': 'Assistant Mechanic', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 75, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:02:13.930Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:02:13.930Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1074, 'name': 'Trailer Repair', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 75, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:02:19.477Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:02:19.477Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1075, 'name': 'Inventory', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 76, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:02:27.770Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:02:27.770Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1076, 'name': 'Locomotive Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 77, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:03:04.001Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:03:21.648Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1077, 'name': 'Port Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 77, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:03:14.308Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:03:14.308Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1078, 'name': 'Truck Scales', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 77, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:03:17.827Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:03:17.827Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1079, 'name': 'Traffic Personnel', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 78, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:03:43.142Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:03:43.142Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1080, 'name': 'Truck Scales', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 79, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:03:59.697Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:03:59.697Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1081, 'name': 'Traffic Personnel', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 79, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:04:06.126Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:04:06.126Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1082, 'name': 'Assistant Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 80, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:04:22.438Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:04:22.438Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1083, 'name': 'Taylor Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 80, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:04:30.931Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:04:30.931Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1084, 'name': 'Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 80, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:04:40.950Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:04:40.950Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1085, 'name': 'Shipper Loader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 80, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:04:54.340Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:04:54.340Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1086, 'name': 'Shuttle Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 80, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:04:58.591Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:04:58.591Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1087, 'name': 'Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 80, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:05:01.598Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:05:01.598Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1088, 'name': 'Assistant Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 81, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:05:11.258Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:05:11.258Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1090, 'name': 'Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 81, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:05:18.863Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:05:18.863Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1091, 'name': 'Shipper Loader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 81, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:05:34.066Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:05:34.066Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1092, 'name': 'Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 81, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:06:12.470Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:06:12.470Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1093, 'name': 'Assistant Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 82, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:06:26.650Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:06:26.650Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1094, 'name': 'Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 82, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:06:40.797Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:06:40.797Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1095, 'name': 'Shipper Loader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 82, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:06:46.289Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:06:46.289Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1096, 'name': 'Shuttle Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 82, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:06:49.984Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:06:49.984Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1097, 'name': 'Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 82, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:06:54.428Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:06:54.428Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1100, 'name': 'Assistant Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 83, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:07:58.777Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:07:58.777Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1101, 'name': 'Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 83, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:08:06.031Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:08:06.031Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1102, 'name': 'Shipper Loader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 83, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:08:11.548Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:08:11.548Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1103, 'name': 'Shuttle Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 83, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:08:16.891Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:08:16.891Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1105, 'name': 'Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 83, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-19T16:08:22.443Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-19T16:08:22.443Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1108, 'name': 'Environmental Manager', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 64, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-20T19:24:20.917Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-20T19:24:20.917Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1110, 'name': 'Roll Designer', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 975, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-20T19:44:28.060Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-20T19:44:28.060Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1111, 'name': '153', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 7, 'rank': 19, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-20T20:07:41.163Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-20T20:07:41.163Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1112, 'name': 'Roll Mill Manager', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 1111, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-20T20:07:53.017Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-20T20:07:53.017Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1113, 'name': 'Roll Shop Lead Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 58, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-20T21:11:47.299Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-20T21:11:47.299Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1114, 'name': 'Utility Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 61, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-20T21:18:08.840Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-20T21:18:08.840Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1115, 'name': '151', 'nodeDetailTypeId': 1, 'nodeTypeId': 3, 'treeId': 1, 'parent': 5, 'rank': 21, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-20T21:37:17.124Z', 'modifiedBy': 1, 'modifiedDate': '2016-07-20T21:37:17.124Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1116, 'name': 'Melt Shop Manager', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 1115, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-07-20T21:37:29.217Z', 'modifiedBy': 1, 'modifiedDate': '2016-09-20T21:57:51.504Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 1125, 'name': 'MULA, ANTHONY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 90, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.083Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.083Z', 'userAccount': { 'userAccountId': 656 }, 'equipment': null, 'owner': null }, { 'nodeId': 1126, 'name': 'GRAY, BERNICE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 92, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.083Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.083Z', 'userAccount': { 'userAccountId': 650 }, 'equipment': null, 'owner': null }, { 'nodeId': 1127, 'name': 'JONES, LAUREN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 92, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.083Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.083Z', 'userAccount': { 'userAccountId': 653 }, 'equipment': null, 'owner': null }, { 'nodeId': 1128, 'name': 'CLAYBROOKS, HERROD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 93, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.083Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.083Z', 'userAccount': { 'userAccountId': 644 }, 'equipment': null, 'owner': null }, { 'nodeId': 1129, 'name': 'DELANCEY, RICKY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 93, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.083Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.083Z', 'userAccount': { 'userAccountId': 646 }, 'equipment': null, 'owner': null }, { 'nodeId': 1130, 'name': 'DYER JR, BILLY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 93, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.083Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.083Z', 'userAccount': { 'userAccountId': 647 }, 'equipment': null, 'owner': null }, { 'nodeId': 1131, 'name': 'GILBERT, DONNA', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 93, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.083Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.083Z', 'userAccount': { 'userAccountId': 648 }, 'equipment': null, 'owner': null }, { 'nodeId': 1132, 'name': 'GOZELL, MARTIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 93, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.083Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.083Z', 'userAccount': { 'userAccountId': 649 }, 'equipment': null, 'owner': null }, { 'nodeId': 1133, 'name': 'DEAN, STANLEY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 93, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.083Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.083Z', 'userAccount': { 'userAccountId': 645 }, 'equipment': null, 'owner': null }, { 'nodeId': 1134, 'name': 'KELLEMS, GARY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 93, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.083Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.083Z', 'userAccount': { 'userAccountId': 654 }, 'equipment': null, 'owner': null }, { 'nodeId': 1135, 'name': 'MELLADY, MARK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 93, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.083Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.083Z', 'userAccount': { 'userAccountId': 655 }, 'equipment': null, 'owner': null }, { 'nodeId': 1136, 'name': 'WILLIAMS, ZACHARY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 93, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.083Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.083Z', 'userAccount': { 'userAccountId': 657 }, 'equipment': null, 'owner': null }, { 'nodeId': 1137, 'name': 'HENRY, PATRICK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 93, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.083Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.083Z', 'userAccount': { 'userAccountId': 651 }, 'equipment': null, 'owner': null }, { 'nodeId': 1138, 'name': 'JAMES, LUCAS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 93, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.083Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.083Z', 'userAccount': { 'userAccountId': 652 }, 'equipment': null, 'owner': null }, { 'nodeId': 1139, 'name': 'HOLMES, KEVIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 107, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.083Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.083Z', 'userAccount': { 'userAccountId': 741 }, 'equipment': null, 'owner': null }, { 'nodeId': 1140, 'name': 'MYERS, BOBBY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 107, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.083Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.083Z', 'userAccount': { 'userAccountId': 743 }, 'equipment': null, 'owner': null }, { 'nodeId': 1141, 'name': 'WARREN, BRANDON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 107, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.083Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.083Z', 'userAccount': { 'userAccountId': 748 }, 'equipment': null, 'owner': null }, { 'nodeId': 1142, 'name': 'FULKS, JOHN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 138, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.083Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.083Z', 'userAccount': { 'userAccountId': 815 }, 'equipment': null, 'owner': null }, { 'nodeId': 1143, 'name': 'LEDBETTER, RICKEY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 155, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-08-10T18:18:32.083Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.083Z', 'userAccount': { 'userAccountId': 1538 }, 'equipment': null, 'owner': null }, { 'nodeId': 1144, 'name': 'VASSAR, JERRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 98, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.083Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.083Z', 'userAccount': { 'userAccountId': 676 }, 'equipment': null, 'owner': null }, { 'nodeId': 1145, 'name': 'CHILDERS, SHERRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 99, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.083Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.083Z', 'userAccount': { 'userAccountId': 673 }, 'equipment': null, 'owner': null }, { 'nodeId': 1146, 'name': 'CHILDERS, STEPHEN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2781, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.083Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.083Z', 'userAccount': { 'userAccountId': 674 }, 'equipment': null, 'owner': null }, { 'nodeId': 1147, 'name': 'COLLIER, WILLIAM', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 101, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.083Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.083Z', 'userAccount': { 'userAccountId': 675 }, 'equipment': null, 'owner': null }, { 'nodeId': 1148, 'name': 'WREN, GARY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 165, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 736 }, 'equipment': null, 'owner': null }, { 'nodeId': 1149, 'name': 'COBB, RODNEY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 103, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 710 }, 'equipment': null, 'owner': null }, { 'nodeId': 1150, 'name': 'FORD, TERRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 103, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 711 }, 'equipment': null, 'owner': null }, { 'nodeId': 1151, 'name': 'MASSEY, CHRIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 103, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 712 }, 'equipment': null, 'owner': null }, { 'nodeId': 1152, 'name': 'STANDRIDGE, EDDIE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 103, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 713 }, 'equipment': null, 'owner': null }, { 'nodeId': 1153, 'name': 'RAMSDELL, RICK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 168, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 735 }, 'equipment': null, 'owner': null }, { 'nodeId': 1154, 'name': 'KING, DARYL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 105, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 742 }, 'equipment': null, 'owner': null }, { 'nodeId': 1155, 'name': 'BRANDON, LEON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 107, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 737 }, 'equipment': null, 'owner': null }, { 'nodeId': 1156, 'name': 'SHOUSE, BILL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 107, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 744 }, 'equipment': null, 'owner': null }, { 'nodeId': 1157, 'name': 'TRIPOD, JEFF', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 107, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 746 }, 'equipment': null, 'owner': null }, { 'nodeId': 1158, 'name': 'WARD, DAVID', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 107, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 747 }, 'equipment': null, 'owner': null }, { 'nodeId': 1159, 'name': 'CORNELIUS, CHRIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 107, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 738 }, 'equipment': null, 'owner': null }, { 'nodeId': 1160, 'name': 'EUBANKS, TERRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 107, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 739 }, 'equipment': null, 'owner': null }, { 'nodeId': 1161, 'name': 'HARVEL, ROBERT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 107, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 740 }, 'equipment': null, 'owner': null }, { 'nodeId': 1162, 'name': 'SMITH, TROY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 107, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 745 }, 'equipment': null, 'owner': null }, { 'nodeId': 1163, 'name': 'ENOCHS, MARK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 108, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 751 }, 'equipment': null, 'owner': null }, { 'nodeId': 1164, 'name': 'JORDAN, WALTER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 109, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 753 }, 'equipment': null, 'owner': null }, { 'nodeId': 1165, 'name': 'OSAGIE, SUNNY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 110, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 759 }, 'equipment': null, 'owner': null }, { 'nodeId': 1166, 'name': 'MIDDLETON, STACY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 111, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 757 }, 'equipment': null, 'owner': null }, { 'nodeId': 1167, 'name': 'WESTMORELAND, KEN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 111, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 762 }, 'equipment': null, 'owner': null }, { 'nodeId': 1168, 'name': 'BURNS, KELLY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 111, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 749 }, 'equipment': null, 'owner': null }, { 'nodeId': 1169, 'name': 'MCGREGOR, MICKEY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 111, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 755 }, 'equipment': null, 'owner': null }, { 'nodeId': 1170, 'name': 'SOUTHERN, ALAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 111, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 760 }, 'equipment': null, 'owner': null }, { 'nodeId': 1171, 'name': 'CHIPMAN, ROBERT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 111, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 750 }, 'equipment': null, 'owner': null }, { 'nodeId': 1172, 'name': 'FRENCH, TIMOTHY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 111, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 752 }, 'equipment': null, 'owner': null }, { 'nodeId': 1173, 'name': 'LINDNER, FREDERICK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 111, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 754 }, 'equipment': null, 'owner': null }, { 'nodeId': 1174, 'name': 'SUAREZ, NELSON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 111, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 761 }, 'equipment': null, 'owner': null }, { 'nodeId': 1175, 'name': 'MEADOR, PHILLIP', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 112, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 756 }, 'equipment': null, 'owner': null }, { 'nodeId': 1176, 'name': 'MILLER, RICHARD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 112, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 758 }, 'equipment': null, 'owner': null }, { 'nodeId': 1177, 'name': 'SMITH, RICKEY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 113, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 770 }, 'equipment': null, 'owner': null }, { 'nodeId': 1178, 'name': 'LINDSEY, WILLIAM', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 124, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 766 }, 'equipment': null, 'owner': null }, { 'nodeId': 1179, 'name': 'REYNOLDS, THOMAS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 127, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 769 }, 'equipment': null, 'owner': null }, { 'nodeId': 1180, 'name': 'MCNATT, KENNETH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 127, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 768 }, 'equipment': null, 'owner': null }, { 'nodeId': 1181, 'name': 'BRODIE, KELLY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 127, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 763 }, 'equipment': null, 'owner': null }, { 'nodeId': 1182, 'name': 'BRYEANS, CHARLES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 127, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 764 }, 'equipment': null, 'owner': null }, { 'nodeId': 1183, 'name': 'KELLEMS, CHRIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 127, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 765 }, 'equipment': null, 'owner': null }, { 'nodeId': 1184, 'name': 'LOWERY, WILLIAM', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 127, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 767 }, 'equipment': null, 'owner': null }, { 'nodeId': 1185, 'name': 'STRAWN, BOB', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 114, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 791 }, 'equipment': null, 'owner': null }, { 'nodeId': 1186, 'name': 'CIEPIELA, KEITH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 128, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.084Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.084Z', 'userAccount': { 'userAccountId': 772 }, 'equipment': null, 'owner': null }, { 'nodeId': 1187, 'name': 'SCOTT, BOBBY DEAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 128, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 788 }, 'equipment': null, 'owner': null }, { 'nodeId': 1188, 'name': 'GARNER, JEREMY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 129, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 775 }, 'equipment': null, 'owner': null }, { 'nodeId': 1189, 'name': 'DANIEL, ERLWIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2783, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 773 }, 'equipment': null, 'owner': null }, { 'nodeId': 1190, 'name': 'GRAHAM, RONNY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 131, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 777 }, 'equipment': null, 'owner': null }, { 'nodeId': 1191, 'name': 'LACK, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 131, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 780 }, 'equipment': null, 'owner': null }, { 'nodeId': 1192, 'name': 'LASTER, JERRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 131, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 781 }, 'equipment': null, 'owner': null }, { 'nodeId': 1193, 'name': 'MCCANLESS, TERRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 131, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 782 }, 'equipment': null, 'owner': null }, { 'nodeId': 1194, 'name': 'MOORE, RAYMOND', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 131, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 783 }, 'equipment': null, 'owner': null }, { 'nodeId': 1195, 'name': 'POE, SHANNON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 131, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 784 }, 'equipment': null, 'owner': null }, { 'nodeId': 1196, 'name': 'SHECKELL, ALAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 131, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 789 }, 'equipment': null, 'owner': null }, { 'nodeId': 1197, 'name': 'BRYANT, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 131, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 771 }, 'equipment': null, 'owner': null }, { 'nodeId': 1198, 'name': 'GORDON, TIMOTHY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 131, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 776 }, 'equipment': null, 'owner': null }, { 'nodeId': 1199, 'name': 'HONCHELL, BENJAMIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 131, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 779 }, 'equipment': null, 'owner': null }, { 'nodeId': 1200, 'name': 'SHUBURTE, RICHARD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 131, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 790 }, 'equipment': null, 'owner': null }, { 'nodeId': 1201, 'name': 'RICH, REX', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 133, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 785 }, 'equipment': null, 'owner': null }, { 'nodeId': 1202, 'name': 'ROSE, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 133, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 786 }, 'equipment': null, 'owner': null }, { 'nodeId': 1203, 'name': 'FRANKS, RONNIE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 134, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 774 }, 'equipment': null, 'owner': null }, { 'nodeId': 1204, 'name': 'HESTER, KEVIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 134, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 778 }, 'equipment': null, 'owner': null }, { 'nodeId': 1205, 'name': 'RUDDICK, TIM', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 134, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 787 }, 'equipment': null, 'owner': null }, { 'nodeId': 1206, 'name': 'BYRD, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 115, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 823 }, 'equipment': null, 'owner': null }, { 'nodeId': 1207, 'name': 'BENNETT, JOHN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 125, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 793 }, 'equipment': null, 'owner': null }, { 'nodeId': 1208, 'name': 'FOWLER, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2785, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 796 }, 'equipment': null, 'owner': null }, { 'nodeId': 1209, 'name': 'LINDSEY, JACKIE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2785, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 800 }, 'equipment': null, 'owner': null }, { 'nodeId': 1210, 'name': 'LONG, JOSHUA', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2785, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 803 }, 'equipment': null, 'owner': null }, { 'nodeId': 1211, 'name': 'AKINS, TOBE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2785, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 792 }, 'equipment': null, 'owner': null }, { 'nodeId': 1212, 'name': 'LIPPS, JOE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2785, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 801 }, 'equipment': null, 'owner': null }, { 'nodeId': 1213, 'name': 'MCCLAIN, MARK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2785, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 804 }, 'equipment': null, 'owner': null }, { 'nodeId': 1214, 'name': 'VINING, CHRISTOPHER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2785, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 808 }, 'equipment': null, 'owner': null }, { 'nodeId': 1215, 'name': 'CLESTER, DESTRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2785, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 795 }, 'equipment': null, 'owner': null }, { 'nodeId': 1216, 'name': 'GLICKERT, CURTIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2785, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 797 }, 'equipment': null, 'owner': null }, { 'nodeId': 1217, 'name': 'MINGLE, TROY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2785, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 806 }, 'equipment': null, 'owner': null }, { 'nodeId': 1218, 'name': 'PENKUNAS, DUSTIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2785, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 807 }, 'equipment': null, 'owner': null }, { 'nodeId': 1219, 'name': 'BROMLEY, DANIEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2785, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 794 }, 'equipment': null, 'owner': null }, { 'nodeId': 1220, 'name': 'GREEN, DAVID', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2785, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 798 }, 'equipment': null, 'owner': null }, { 'nodeId': 1221, 'name': 'LASTER, RANDY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2785, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 799 }, 'equipment': null, 'owner': null }, { 'nodeId': 1222, 'name': 'LOGSDON, JEFFREY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2785, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 802 }, 'equipment': null, 'owner': null }, { 'nodeId': 1223, 'name': 'FULBRIGHT, ERIC', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 116, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 814 }, 'equipment': null, 'owner': null }, { 'nodeId': 1224, 'name': 'HUNT, KENNETH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 136, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 818 }, 'equipment': null, 'owner': null }, { 'nodeId': 1225, 'name': 'DURHAM, TODD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 137, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 811 }, 'equipment': null, 'owner': null }, { 'nodeId': 1226, 'name': 'WARREN, FORREST', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 138, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 822 }, 'equipment': null, 'owner': null }, { 'nodeId': 1227, 'name': 'CHANDLER, MATTHEW', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 138, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 809 }, 'equipment': null, 'owner': null }, { 'nodeId': 1228, 'name': 'CLAYTON, DUSTY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 138, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 810 }, 'equipment': null, 'owner': null }, { 'nodeId': 1229, 'name': 'HARGRAVE, RICHARD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 138, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 816 }, 'equipment': null, 'owner': null }, { 'nodeId': 1230, 'name': 'SAMPLE, MATTHEW', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 138, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.085Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.085Z', 'userAccount': { 'userAccountId': 820 }, 'equipment': null, 'owner': null }, { 'nodeId': 1231, 'name': 'FARLEY, KENNETH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 138, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 812 }, 'equipment': null, 'owner': null }, { 'nodeId': 1232, 'name': 'FORSYTHE, JEFFERY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 138, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 813 }, 'equipment': null, 'owner': null }, { 'nodeId': 1233, 'name': 'HATCHEL, MATTHEW', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 138, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 817 }, 'equipment': null, 'owner': null }, { 'nodeId': 1234, 'name': 'TOWELL, CURTIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 138, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 821 }, 'equipment': null, 'owner': null }, { 'nodeId': 1235, 'name': 'MILES, ERIC', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 117, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 805 }, 'equipment': null, 'owner': null }, { 'nodeId': 1236, 'name': 'ROSCOE, TODD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 126, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 830 }, 'equipment': null, 'owner': null }, { 'nodeId': 1237, 'name': 'RABEY, GARY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 139, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 829 }, 'equipment': null, 'owner': null }, { 'nodeId': 1238, 'name': 'KETCHUM, LEE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 140, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 827 }, 'equipment': null, 'owner': null }, { 'nodeId': 1239, 'name': 'ROSE, DILLON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 140, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 831 }, 'equipment': null, 'owner': null }, { 'nodeId': 1240, 'name': 'ZIMMERMAN, DENNIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 140, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 836 }, 'equipment': null, 'owner': null }, { 'nodeId': 1241, 'name': 'EARHART, SCOTT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 140, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 825 }, 'equipment': null, 'owner': null }, { 'nodeId': 1242, 'name': 'HURLEY, BRIAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 140, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 826 }, 'equipment': null, 'owner': null }, { 'nodeId': 1243, 'name': 'TIMMERBERG, CHRIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 140, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 833 }, 'equipment': null, 'owner': null }, { 'nodeId': 1244, 'name': 'WALLER, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 140, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 835 }, 'equipment': null, 'owner': null }, { 'nodeId': 1245, 'name': 'DUNN, PRESTON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 140, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 824 }, 'equipment': null, 'owner': null }, { 'nodeId': 1246, 'name': 'PARKER, JACOB', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 140, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 828 }, 'equipment': null, 'owner': null }, { 'nodeId': 1247, 'name': 'STEUBER, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 140, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 832 }, 'equipment': null, 'owner': null }, { 'nodeId': 1248, 'name': 'TIREY, ALAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 140, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 834 }, 'equipment': null, 'owner': null }, { 'nodeId': 1249, 'name': 'BOSWELL, ROBERT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 118, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 838 }, 'equipment': null, 'owner': null }, { 'nodeId': 1250, 'name': 'LASTER JR, RANDY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2787, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 856 }, 'equipment': null, 'owner': null }, { 'nodeId': 1251, 'name': 'CARTER, SCOTT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 142, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 840 }, 'equipment': null, 'owner': null }, { 'nodeId': 1252, 'name': 'AVERY, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 142, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 837 }, 'equipment': null, 'owner': null }, { 'nodeId': 1253, 'name': 'BROWNING, LARRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 142, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 839 }, 'equipment': null, 'owner': null }, { 'nodeId': 1254, 'name': 'MEREDITH, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 142, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 844 }, 'equipment': null, 'owner': null }, { 'nodeId': 1255, 'name': 'SIMONS, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 142, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 848 }, 'equipment': null, 'owner': null }, { 'nodeId': 1256, 'name': 'HOOKER, HEATH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2786, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 843 }, 'equipment': null, 'owner': null }, { 'nodeId': 1257, 'name': 'COLLIER, JOSEPH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 143, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 841 }, 'equipment': null, 'owner': null }, { 'nodeId': 1258, 'name': 'DACUS, ZACHARY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 143, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 842 }, 'equipment': null, 'owner': null }, { 'nodeId': 1259, 'name': 'PAYNE, TOMMY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 143, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 846 }, 'equipment': null, 'owner': null }, { 'nodeId': 1260, 'name': 'PHILLIPS, BRETT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 143, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 847 }, 'equipment': null, 'owner': null }, { 'nodeId': 1261, 'name': 'MILLER, RAYMON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 144, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 845 }, 'equipment': null, 'owner': null }, { 'nodeId': 1262, 'name': 'JENKINS, JOHNNY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 145, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 855 }, 'equipment': null, 'owner': null }, { 'nodeId': 1263, 'name': 'SHARMA, DHARAM', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 146, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 857 }, 'equipment': null, 'owner': null }, { 'nodeId': 1264, 'name': 'HANDLEY, ROGER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 147, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 853 }, 'equipment': null, 'owner': null }, { 'nodeId': 1265, 'name': 'BAKER, KENNETH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 148, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 849 }, 'equipment': null, 'owner': null }, { 'nodeId': 1266, 'name': 'DYCUS, STEPHEN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 148, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.086Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.086Z', 'userAccount': { 'userAccountId': 850 }, 'equipment': null, 'owner': null }, { 'nodeId': 1267, 'name': 'FUNDERBURK, JOHNNY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 148, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 851 }, 'equipment': null, 'owner': null }, { 'nodeId': 1268, 'name': 'GEORGE, THOMAS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 148, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 852 }, 'equipment': null, 'owner': null }, { 'nodeId': 1269, 'name': 'HAWKINS, GREGORY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 148, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 854 }, 'equipment': null, 'owner': null }, { 'nodeId': 1270, 'name': 'RIDINGS, EDDIE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 120, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 866 }, 'equipment': null, 'owner': null }, { 'nodeId': 1271, 'name': 'EDEN, DARRELL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 149, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 862 }, 'equipment': null, 'owner': null }, { 'nodeId': 1272, 'name': 'BAIRD, BRUCE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 150, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 858 }, 'equipment': null, 'owner': null }, { 'nodeId': 1273, 'name': 'DANIEL, SHAD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 150, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 861 }, 'equipment': null, 'owner': null }, { 'nodeId': 1274, 'name': 'TURNER, KEITH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 150, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 867 }, 'equipment': null, 'owner': null }, { 'nodeId': 1275, 'name': 'WARD, CHRISTOPHER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 150, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 868 }, 'equipment': null, 'owner': null }, { 'nodeId': 1276, 'name': 'WILLIAMS, MATT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 150, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 869 }, 'equipment': null, 'owner': null }, { 'nodeId': 1277, 'name': 'BROWN, MAX', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 150, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 859 }, 'equipment': null, 'owner': null }, { 'nodeId': 1278, 'name': 'GARRETT, RATT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 150, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 863 }, 'equipment': null, 'owner': null }, { 'nodeId': 1279, 'name': 'HILL, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 150, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 864 }, 'equipment': null, 'owner': null }, { 'nodeId': 1280, 'name': 'MILLER, KENNETH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 150, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 865 }, 'equipment': null, 'owner': null }, { 'nodeId': 1281, 'name': 'COPELAND, CHARLES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 151, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 860 }, 'equipment': null, 'owner': null }, { 'nodeId': 1282, 'name': 'ZIEGLER, CHRIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 121, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 879 }, 'equipment': null, 'owner': null }, { 'nodeId': 1283, 'name': 'BREES, DAVID', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 152, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 870 }, 'equipment': null, 'owner': null }, { 'nodeId': 1284, 'name': 'PELCZYNSKI, ROME', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2788, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 876 }, 'equipment': null, 'owner': null }, { 'nodeId': 1285, 'name': 'SMITH, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 154, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 877 }, 'equipment': null, 'owner': null }, { 'nodeId': 1286, 'name': 'LAMPE, MARK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 155, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 874 }, 'equipment': null, 'owner': null }, { 'nodeId': 1287, 'name': 'DENNIS, CLAYTON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 155, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 871 }, 'equipment': null, 'owner': null }, { 'nodeId': 1288, 'name': 'HAGEMAN, RYAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 155, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 872 }, 'equipment': null, 'owner': null }, { 'nodeId': 1289, 'name': 'HARPER, DEAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 155, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 873 }, 'equipment': null, 'owner': null }, { 'nodeId': 1290, 'name': 'PANKEY, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 155, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 875 }, 'equipment': null, 'owner': null }, { 'nodeId': 1291, 'name': 'WILKERSON, JOSEPH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 155, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 878 }, 'equipment': null, 'owner': null }, { 'nodeId': 1292, 'name': 'BELL, DAVID', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 122, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 880 }, 'equipment': null, 'owner': null }, { 'nodeId': 1293, 'name': 'BLACK, BILL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 156, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 881 }, 'equipment': null, 'owner': null }, { 'nodeId': 1294, 'name': 'HEINRICH, GARY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 157, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 884 }, 'equipment': null, 'owner': null }, { 'nodeId': 1295, 'name': 'LEE, DANNY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 157, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 887 }, 'equipment': null, 'owner': null }, { 'nodeId': 1296, 'name': 'STAGGS, KIM', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 158, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 890 }, 'equipment': null, 'owner': null }, { 'nodeId': 1297, 'name': 'WARREN, MELVIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 158, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 892 }, 'equipment': null, 'owner': null }, { 'nodeId': 1298, 'name': 'ENSOR, PAUL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 158, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 882 }, 'equipment': null, 'owner': null }, { 'nodeId': 1299, 'name': 'RIDINGS, JOHN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 158, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 888 }, 'equipment': null, 'owner': null }, { 'nodeId': 1300, 'name': 'SAWYER, LARRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 158, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 889 }, 'equipment': null, 'owner': null }, { 'nodeId': 1301, 'name': 'THAXTON, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 158, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 891 }, 'equipment': null, 'owner': null }, { 'nodeId': 1302, 'name': 'GILLOCK, WILLIAM', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 158, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 883 }, 'equipment': null, 'owner': null }, { 'nodeId': 1303, 'name': 'IBANEZ, RANDY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 158, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 885 }, 'equipment': null, 'owner': null }, { 'nodeId': 1304, 'name': 'JARRED, DALLAS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 158, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 886 }, 'equipment': null, 'owner': null }, { 'nodeId': 1305, 'name': 'WHITE, ROD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 158, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.087Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.087Z', 'userAccount': { 'userAccountId': 893 }, 'equipment': null, 'owner': null }, { 'nodeId': 1306, 'name': 'CIEPIELA, JASON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 123, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 896 }, 'equipment': null, 'owner': null }, { 'nodeId': 1307, 'name': 'BURKE, RICHIE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 159, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 895 }, 'equipment': null, 'owner': null }, { 'nodeId': 1308, 'name': 'BARCLAY, JERRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 160, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 894 }, 'equipment': null, 'owner': null }, { 'nodeId': 1309, 'name': 'NELSON, JORY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 160, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 900 }, 'equipment': null, 'owner': null }, { 'nodeId': 1310, 'name': 'RAY, DAVID', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 160, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 901 }, 'equipment': null, 'owner': null }, { 'nodeId': 1311, 'name': 'WOOD, JOE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 160, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 902 }, 'equipment': null, 'owner': null }, { 'nodeId': 1312, 'name': 'CIEPIELA, KEITH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 160, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 897 }, 'equipment': null, 'owner': null }, { 'nodeId': 1313, 'name': 'MEJIA, TOBY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 160, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 899 }, 'equipment': null, 'owner': null }, { 'nodeId': 1314, 'name': 'GARRETT, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 286, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 722 }, 'equipment': null, 'owner': null }, { 'nodeId': 1315, 'name': 'GRAY, CHRISSIE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 287, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 724 }, 'equipment': null, 'owner': null }, { 'nodeId': 1316, 'name': 'HODGE, TONY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 288, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 726 }, 'equipment': null, 'owner': null }, { 'nodeId': 1317, 'name': 'STRINGER, RYAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 288, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 733 }, 'equipment': null, 'owner': null }, { 'nodeId': 1318, 'name': 'ASHLEY, THOMAS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 289, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 715 }, 'equipment': null, 'owner': null }, { 'nodeId': 1319, 'name': 'BAKER, ADAM', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 289, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 716 }, 'equipment': null, 'owner': null }, { 'nodeId': 1320, 'name': 'BRIZENDINE, CHRIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 289, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 718 }, 'equipment': null, 'owner': null }, { 'nodeId': 1321, 'name': 'DAY, CLYDE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 289, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 720 }, 'equipment': null, 'owner': null }, { 'nodeId': 1322, 'name': 'GRAVES, JOHN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 289, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 723 }, 'equipment': null, 'owner': null }, { 'nodeId': 1323, 'name': 'HOPPER, LYNN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 289, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 727 }, 'equipment': null, 'owner': null }, { 'nodeId': 1324, 'name': 'LOVE, KEVIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 289, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 729 }, 'equipment': null, 'owner': null }, { 'nodeId': 1325, 'name': 'MAYS, GEORGE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 289, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 730 }, 'equipment': null, 'owner': null }, { 'nodeId': 1326, 'name': 'SATTERFIELD, ROBERT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 289, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 731 }, 'equipment': null, 'owner': null }, { 'nodeId': 1327, 'name': 'TATE, BOBBY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 289, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 734 }, 'equipment': null, 'owner': null }, { 'nodeId': 1328, 'name': 'BRIDGES, DAVID', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 290, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 717 }, 'equipment': null, 'owner': null }, { 'nodeId': 1329, 'name': 'EDMONSTON, JUSTIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 291, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 721 }, 'equipment': null, 'owner': null }, { 'nodeId': 1330, 'name': 'HADDOCK, BROCK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 291, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 725 }, 'equipment': null, 'owner': null }, { 'nodeId': 1331, 'name': 'JOHNSON, SCOTT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 291, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 728 }, 'equipment': null, 'owner': null }, { 'nodeId': 1332, 'name': 'STAHL, BRIAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 291, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 732 }, 'equipment': null, 'owner': null }, { 'nodeId': 1333, 'name': 'CAPEHART, DENICE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2766, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 582 }, 'equipment': null, 'owner': null }, { 'nodeId': 1334, 'name': 'COOPER, LACEY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2766, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 583 }, 'equipment': null, 'owner': null }, { 'nodeId': 1335, 'name': 'HOLLINGSEAD, KRISTEN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2764, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 584 }, 'equipment': null, 'owner': null }, { 'nodeId': 1336, 'name': 'MOORE, LORI', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2766, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 585 }, 'equipment': null, 'owner': null }, { 'nodeId': 1337, 'name': 'SINGLETON, WYVONIA', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2766, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 586 }, 'equipment': null, 'owner': null }, { 'nodeId': 1338, 'name': 'SOUTHERN, ANNA', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2766, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 587 }, 'equipment': null, 'owner': null }, { 'nodeId': 1339, 'name': 'STEPHENS, CHAROLETT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2766, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 588 }, 'equipment': null, 'owner': null }, { 'nodeId': 1340, 'name': 'CROUCH, GARY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 296, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 581 }, 'equipment': null, 'owner': null }, { 'nodeId': 1341, 'name': 'HARTGRAVES, LARRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 715, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.088Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.088Z', 'userAccount': { 'userAccountId': 184 }, 'equipment': null, 'owner': null }, { 'nodeId': 1342, 'name': 'ROACH, DANIEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 716, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 186 }, 'equipment': null, 'owner': null }, { 'nodeId': 1343, 'name': 'BURNS, CARL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2688, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 181 }, 'equipment': null, 'owner': null }, { 'nodeId': 1344, 'name': 'COUNTS, PAUL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2694, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 182 }, 'equipment': null, 'owner': null }, { 'nodeId': 1345, 'name': 'PARKER, KEITH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 719, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 136 }, 'equipment': null, 'owner': null }, { 'nodeId': 1346, 'name': 'DOGAN, JACOB', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 720, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 130 }, 'equipment': null, 'owner': null }, { 'nodeId': 1347, 'name': 'DYCUS, HEATH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 720, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 131 }, 'equipment': null, 'owner': null }, { 'nodeId': 1348, 'name': 'GRIMMER, LYLE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 720, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 133 }, 'equipment': null, 'owner': null }, { 'nodeId': 1349, 'name': 'GILBOW, LAYNE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2683, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 132 }, 'equipment': null, 'owner': null }, { 'nodeId': 1350, 'name': 'RAMSEY, KELTON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2683, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 137 }, 'equipment': null, 'owner': null }, { 'nodeId': 1351, 'name': 'RITCHEY, DANIEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2683, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 140 }, 'equipment': null, 'owner': null }, { 'nodeId': 1352, 'name': 'SHELTON, NOAH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2683, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 141 }, 'equipment': null, 'owner': null }, { 'nodeId': 1353, 'name': 'REDMAN, JASON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 722, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 138 }, 'equipment': null, 'owner': null }, { 'nodeId': 1354, 'name': 'THAXTON, CURTIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 723, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 142 }, 'equipment': null, 'owner': null }, { 'nodeId': 1355, 'name': 'CASH, DEWAYNE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 724, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 144 }, 'equipment': null, 'owner': null }, { 'nodeId': 1356, 'name': 'DAVIS, ANTHONY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 725, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 147 }, 'equipment': null, 'owner': null }, { 'nodeId': 1357, 'name': 'CANNON, WESLEY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2685, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 143 }, 'equipment': null, 'owner': null }, { 'nodeId': 1358, 'name': 'JONES, DAVID', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2685, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 149 }, 'equipment': null, 'owner': null }, { 'nodeId': 1359, 'name': 'PARKER, TONY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2685, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 152 }, 'equipment': null, 'owner': null }, { 'nodeId': 1360, 'name': 'SIMMONS, JONATHAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2685, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 154 }, 'equipment': null, 'owner': null }, { 'nodeId': 1361, 'name': 'VANDYKE, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2685, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 155 }, 'equipment': null, 'owner': null }, { 'nodeId': 1362, 'name': 'COLE, JACOB', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 727, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 146 }, 'equipment': null, 'owner': null }, { 'nodeId': 1363, 'name': 'CLARK, CHRISTOPHER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 728, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 145 }, 'equipment': null, 'owner': null }, { 'nodeId': 1364, 'name': 'CURTIS, PAUL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 729, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 159 }, 'equipment': null, 'owner': null }, { 'nodeId': 1365, 'name': 'TOWLES, SCOTT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 730, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 169 }, 'equipment': null, 'owner': null }, { 'nodeId': 1366, 'name': 'DAY, CLYDE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2686, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 160 }, 'equipment': null, 'owner': null }, { 'nodeId': 1367, 'name': 'GARNER, MATTHEW', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2686, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 161 }, 'equipment': null, 'owner': null }, { 'nodeId': 1368, 'name': 'GEE, DUSTIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2686, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 162 }, 'equipment': null, 'owner': null }, { 'nodeId': 1369, 'name': 'STRANGE, TODD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2686, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 167 }, 'equipment': null, 'owner': null }, { 'nodeId': 1370, 'name': 'GLISSON, DAVID', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 732, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 163 }, 'equipment': null, 'owner': null }, { 'nodeId': 1371, 'name': 'TAYLOR, BILLY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 733, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 168 }, 'equipment': null, 'owner': null }, { 'nodeId': 1372, 'name': 'JOHNSON, GREG', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 734, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 134 }, 'equipment': null, 'owner': null }, { 'nodeId': 1373, 'name': 'MILLER, TRAVIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 734, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 135 }, 'equipment': null, 'owner': null }, { 'nodeId': 1374, 'name': 'REYES, JOHNNY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 734, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 139 }, 'equipment': null, 'owner': null }, { 'nodeId': 1375, 'name': 'MILLER, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 735, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 151 }, 'equipment': null, 'owner': null }, { 'nodeId': 1376, 'name': 'SEIBERT, LARRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 735, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 153 }, 'equipment': null, 'owner': null }, { 'nodeId': 1377, 'name': 'WILLIAMS, SEAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 735, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 157 }, 'equipment': null, 'owner': null }, { 'nodeId': 1378, 'name': 'APPLE, TODD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 736, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 158 }, 'equipment': null, 'owner': null }, { 'nodeId': 1379, 'name': 'RINEHART, GLENN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 736, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 165 }, 'equipment': null, 'owner': null }, { 'nodeId': 1380, 'name': 'SMALLWOOD, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 736, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.089Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.089Z', 'userAccount': { 'userAccountId': 166 }, 'equipment': null, 'owner': null }, { 'nodeId': 1381, 'name': 'HENDERSON, JEFFREY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 737, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 174 }, 'equipment': null, 'owner': null }, { 'nodeId': 1382, 'name': 'MCBRIDE, TERRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 738, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 175 }, 'equipment': null, 'owner': null }, { 'nodeId': 1383, 'name': 'DICKSON, RANDALL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2690, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 171 }, 'equipment': null, 'owner': null }, { 'nodeId': 1384, 'name': 'HAMLETT, JEREME', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2690, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 172 }, 'equipment': null, 'owner': null }, { 'nodeId': 1385, 'name': 'SANDERS, WILLIAM', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 739, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 176 }, 'equipment': null, 'owner': null }, { 'nodeId': 1386, 'name': 'WARRENFELLS, GEORGE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2690, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 179 }, 'equipment': null, 'owner': null }, { 'nodeId': 1387, 'name': 'SIMS, JOHN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 740, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 177 }, 'equipment': null, 'owner': null }, { 'nodeId': 1388, 'name': 'HAMLETT, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 741, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 173 }, 'equipment': null, 'owner': null }, { 'nodeId': 1389, 'name': 'BLACK, JEREMY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 742, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 170 }, 'equipment': null, 'owner': null }, { 'nodeId': 1390, 'name': 'SWINDLE, JEFFERY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 742, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 178 }, 'equipment': null, 'owner': null }, { 'nodeId': 1391, 'name': 'MORGAN, TONY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2702, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 247 }, 'equipment': null, 'owner': null }, { 'nodeId': 1392, 'name': 'CHATMAN, CHARLES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 744, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 243 }, 'equipment': null, 'owner': null }, { 'nodeId': 1393, 'name': 'BARNES, TRAVIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2698, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 242 }, 'equipment': null, 'owner': null }, { 'nodeId': 1394, 'name': 'FOWLER, JACKIE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 746, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 191 }, 'equipment': null, 'owner': null }, { 'nodeId': 1395, 'name': 'CRUM, JASON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 747, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 189 }, 'equipment': null, 'owner': null }, { 'nodeId': 1396, 'name': 'DARNELL, BRYAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 747, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 190 }, 'equipment': null, 'owner': null }, { 'nodeId': 1397, 'name': 'JOHNSON, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 747, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 194 }, 'equipment': null, 'owner': null }, { 'nodeId': 1398, 'name': 'ROMHILT, JAMEY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 747, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 199 }, 'equipment': null, 'owner': null }, { 'nodeId': 1399, 'name': 'VANDYKE, DAVID', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 747, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 200 }, 'equipment': null, 'owner': null }, { 'nodeId': 1400, 'name': 'MINYARD, ROBBIE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 748, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 196 }, 'equipment': null, 'owner': null }, { 'nodeId': 1401, 'name': 'NEAL, BRANDON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 749, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 197 }, 'equipment': null, 'owner': null }, { 'nodeId': 1402, 'name': 'KING, DAVID', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 750, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 195 }, 'equipment': null, 'owner': null }, { 'nodeId': 1403, 'name': 'HITCHCOCK, BRAD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 751, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 193 }, 'equipment': null, 'owner': null }, { 'nodeId': 1404, 'name': 'CLEAVER, TYLER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2695, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 188 }, 'equipment': null, 'owner': null }, { 'nodeId': 1405, 'name': 'WOODS, LEON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2699, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 227 }, 'equipment': null, 'owner': null }, { 'nodeId': 1406, 'name': 'RIGGS, GARY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 753, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 198 }, 'equipment': null, 'owner': null }, { 'nodeId': 1407, 'name': 'BAKER, CHAD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 754, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 187 }, 'equipment': null, 'owner': null }, { 'nodeId': 1408, 'name': 'GASCOIGNE, SEAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 754, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 192 }, 'equipment': null, 'owner': null }, { 'nodeId': 1409, 'name': 'ANDERSON, TERRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 755, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 202 }, 'equipment': null, 'owner': null }, { 'nodeId': 1410, 'name': 'CAMPBELL, JESSE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 756, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 203 }, 'equipment': null, 'owner': null }, { 'nodeId': 1411, 'name': 'CUNNINGHAM, DEREK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 756, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 204 }, 'equipment': null, 'owner': null }, { 'nodeId': 1412, 'name': 'MADDOX, TERRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 756, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 208 }, 'equipment': null, 'owner': null }, { 'nodeId': 1413, 'name': 'MASK, RICKY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 756, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 209 }, 'equipment': null, 'owner': null }, { 'nodeId': 1414, 'name': 'GRAHAM, GERALD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 757, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 205 }, 'equipment': null, 'owner': null }, { 'nodeId': 1415, 'name': 'ALEXANDER, JEREMY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 758, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 201 }, 'equipment': null, 'owner': null }, { 'nodeId': 1416, 'name': 'HAMM, RAY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 759, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.090Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.090Z', 'userAccount': { 'userAccountId': 207 }, 'equipment': null, 'owner': null }, { 'nodeId': 1417, 'name': 'GRAHAM, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 760, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 206 }, 'equipment': null, 'owner': null }, { 'nodeId': 1418, 'name': 'WIDDICOMBE, JEFFREY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2696, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 212 }, 'equipment': null, 'owner': null }, { 'nodeId': 1419, 'name': 'WILBANKS, CHARLES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 762, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 213 }, 'equipment': null, 'owner': null }, { 'nodeId': 1420, 'name': 'POWELL, ANTHONY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 763, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 210 }, 'equipment': null, 'owner': null }, { 'nodeId': 1421, 'name': 'RICHARDSON, TERRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 763, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 211 }, 'equipment': null, 'owner': null }, { 'nodeId': 1422, 'name': 'RUSSELL, ROMAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 764, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 225 }, 'equipment': null, 'owner': null }, { 'nodeId': 1423, 'name': 'ALLEN, DARIAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 765, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 214 }, 'equipment': null, 'owner': null }, { 'nodeId': 1424, 'name': 'DUFFEL, JERRAD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 765, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 215 }, 'equipment': null, 'owner': null }, { 'nodeId': 1425, 'name': 'ECHOLS, MARK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 765, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 217 }, 'equipment': null, 'owner': null }, { 'nodeId': 1426, 'name': 'EDWARDS, BRENT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 765, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 218 }, 'equipment': null, 'owner': null }, { 'nodeId': 1427, 'name': 'FULTZ, CORY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 765, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 219 }, 'equipment': null, 'owner': null }, { 'nodeId': 1428, 'name': 'JAMISON, JARRED', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 766, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 221 }, 'equipment': null, 'owner': null }, { 'nodeId': 1429, 'name': 'JAMISON, BLAKE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 767, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 220 }, 'equipment': null, 'owner': null }, { 'nodeId': 1430, 'name': 'PAYNE, JONATHAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 768, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 224 }, 'equipment': null, 'owner': null }, { 'nodeId': 1431, 'name': 'DUNCAN, BLAINE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 769, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 216 }, 'equipment': null, 'owner': null }, { 'nodeId': 1432, 'name': 'MOODY, RON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 771, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 222 }, 'equipment': null, 'owner': null }, { 'nodeId': 1433, 'name': 'MORGAN, STEVE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 772, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 223 }, 'equipment': null, 'owner': null }, { 'nodeId': 1434, 'name': 'SKELTON, FOY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 772, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 226 }, 'equipment': null, 'owner': null }, { 'nodeId': 1435, 'name': 'LOMAS, CHRIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 773, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 231 }, 'equipment': null, 'owner': null }, { 'nodeId': 1436, 'name': 'BROWN, LARRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 774, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 228 }, 'equipment': null, 'owner': null }, { 'nodeId': 1437, 'name': 'SPENCER, ADAM', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 774, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 236 }, 'equipment': null, 'owner': null }, { 'nodeId': 1438, 'name': 'THOMPSON, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 774, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 238 }, 'equipment': null, 'owner': null }, { 'nodeId': 1439, 'name': 'VASSAR, ALAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 774, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 240 }, 'equipment': null, 'owner': null }, { 'nodeId': 1440, 'name': 'WILLIAMS, ANDREW', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 774, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 241 }, 'equipment': null, 'owner': null }, { 'nodeId': 1441, 'name': 'PARKER, BUD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 775, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 234 }, 'equipment': null, 'owner': null }, { 'nodeId': 1442, 'name': 'TOMLIN, CODY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 776, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 239 }, 'equipment': null, 'owner': null }, { 'nodeId': 1443, 'name': 'HOPPER, JEFFREY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 777, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 230 }, 'equipment': null, 'owner': null }, { 'nodeId': 1444, 'name': 'TEAGUE, DAVID', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 778, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 237 }, 'equipment': null, 'owner': null }, { 'nodeId': 1445, 'name': 'MOTT, MATTHEW', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2697, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 233 }, 'equipment': null, 'owner': null }, { 'nodeId': 1446, 'name': 'MERRYMAN, BILLY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 780, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 232 }, 'equipment': null, 'owner': null }, { 'nodeId': 1447, 'name': 'FIELD, JOHN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 781, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 229 }, 'equipment': null, 'owner': null }, { 'nodeId': 1448, 'name': 'PELTS, JULIE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 781, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 235 }, 'equipment': null, 'owner': null }, { 'nodeId': 1449, 'name': 'BAKER, ANTHONY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 783, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 497 }, 'equipment': null, 'owner': null }, { 'nodeId': 1450, 'name': 'JOHNSON, DOYLE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 785, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 498 }, 'equipment': null, 'owner': null }, { 'nodeId': 1451, 'name': 'MAYBERRY, DONALD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 785, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 499 }, 'equipment': null, 'owner': null }, { 'nodeId': 1452, 'name': 'CATO, JOHN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 787, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 500 }, 'equipment': null, 'owner': null }, { 'nodeId': 1453, 'name': 'ECHOLS, LONNIE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 787, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 501 }, 'equipment': null, 'owner': null }, { 'nodeId': 1454, 'name': 'BRANDENBURG, CALVIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 789, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 502 }, 'equipment': null, 'owner': null }, { 'nodeId': 1455, 'name': 'WALLACE, CARL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 789, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.091Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.091Z', 'userAccount': { 'userAccountId': 503 }, 'equipment': null, 'owner': null }, { 'nodeId': 1456, 'name': 'MORRIES, DANIEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 791, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 912 }, 'equipment': null, 'owner': null }, { 'nodeId': 1457, 'name': 'ANDERSON, ERIC', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 792, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 903 }, 'equipment': null, 'owner': null }, { 'nodeId': 1458, 'name': 'COOK, RILEY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 792, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 906 }, 'equipment': null, 'owner': null }, { 'nodeId': 1459, 'name': 'RICHARDSON, STEVE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 792, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 913 }, 'equipment': null, 'owner': null }, { 'nodeId': 1460, 'name': 'STOBAUGH, JEREMY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 792, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 914 }, 'equipment': null, 'owner': null }, { 'nodeId': 1461, 'name': 'METCALF, BRUCE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 793, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 911 }, 'equipment': null, 'owner': null }, { 'nodeId': 1462, 'name': 'FLANAGAN, COLE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 795, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 907 }, 'equipment': null, 'owner': null }, { 'nodeId': 1463, 'name': 'KEANE, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 796, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 909 }, 'equipment': null, 'owner': null }, { 'nodeId': 1464, 'name': 'VAUGHN, CHRISTOPHER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 796, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 915 }, 'equipment': null, 'owner': null }, { 'nodeId': 1465, 'name': 'AYERS, ZACHARY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2789, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 904 }, 'equipment': null, 'owner': null }, { 'nodeId': 1466, 'name': 'KELLEY, ELMER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 798, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 910 }, 'equipment': null, 'owner': null }, { 'nodeId': 1467, 'name': 'HARTUNG, NATHANIEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 799, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 908 }, 'equipment': null, 'owner': null }, { 'nodeId': 1468, 'name': 'ARNOLD, EDWARD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2791, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 916 }, 'equipment': null, 'owner': null }, { 'nodeId': 1469, 'name': 'HATCH, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 801, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 922 }, 'equipment': null, 'owner': null }, { 'nodeId': 1470, 'name': 'JACKSON, JOE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 801, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 924 }, 'equipment': null, 'owner': null }, { 'nodeId': 1471, 'name': 'TIPLER, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 801, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 928 }, 'equipment': null, 'owner': null }, { 'nodeId': 1472, 'name': 'BUFFINGTON, TIMOTHY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 802, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 919 }, 'equipment': null, 'owner': null }, { 'nodeId': 1473, 'name': 'CASTELLI, BILLY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 804, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 921 }, 'equipment': null, 'owner': null }, { 'nodeId': 1474, 'name': 'JOHNSON, STEVEN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 804, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 925 }, 'equipment': null, 'owner': null }, { 'nodeId': 1475, 'name': 'CANNON, JERRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 805, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 920 }, 'equipment': null, 'owner': null }, { 'nodeId': 1476, 'name': 'INMAN, DAVID', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 805, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 923 }, 'equipment': null, 'owner': null }, { 'nodeId': 1477, 'name': 'KELLER, NICHOLAS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 805, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 926 }, 'equipment': null, 'owner': null }, { 'nodeId': 1478, 'name': 'BUCHANAN, ALAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2790, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 917 }, 'equipment': null, 'owner': null }, { 'nodeId': 1479, 'name': 'TIFFANY, CHRISTINA', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 808, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 927 }, 'equipment': null, 'owner': null }, { 'nodeId': 1480, 'name': 'BURCHAM, TERRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 809, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 930 }, 'equipment': null, 'owner': null }, { 'nodeId': 1481, 'name': 'CRAIG, MICKEY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 810, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 931 }, 'equipment': null, 'owner': null }, { 'nodeId': 1482, 'name': 'FULTZ, CLIFTON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 810, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 935 }, 'equipment': null, 'owner': null }, { 'nodeId': 1483, 'name': 'SWAN, WILLIAM', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 810, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 939 }, 'equipment': null, 'owner': null }, { 'nodeId': 1484, 'name': 'DYER, BILLY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 811, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 934 }, 'equipment': null, 'owner': null }, { 'nodeId': 1485, 'name': 'BROWN, SAMMY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 813, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.092Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.092Z', 'userAccount': { 'userAccountId': 929 }, 'equipment': null, 'owner': null }, { 'nodeId': 1486, 'name': 'CRANE, CHRISTOPHER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 814, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 932 }, 'equipment': null, 'owner': null }, { 'nodeId': 1487, 'name': 'MOTT, DENNIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 814, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 938 }, 'equipment': null, 'owner': null }, { 'nodeId': 1488, 'name': 'WELLS, CHRIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2792, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 940 }, 'equipment': null, 'owner': null }, { 'nodeId': 1489, 'name': 'GRABLE, DONALD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 816, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 936 }, 'equipment': null, 'owner': null }, { 'nodeId': 1490, 'name': 'DARNELL, THOMAS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 817, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 933 }, 'equipment': null, 'owner': null }, { 'nodeId': 1491, 'name': 'HESS, KENNETH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 818, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 946 }, 'equipment': null, 'owner': null }, { 'nodeId': 1492, 'name': 'MOORE, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2797, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 950 }, 'equipment': null, 'owner': null }, { 'nodeId': 1493, 'name': 'GEE, JAY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 819, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 942 }, 'equipment': null, 'owner': null }, { 'nodeId': 1494, 'name': 'MIDDLEBROOK, MIKE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 819, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 948 }, 'equipment': null, 'owner': null }, { 'nodeId': 1495, 'name': 'MOORE, BRIAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 819, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 949 }, 'equipment': null, 'owner': null }, { 'nodeId': 1496, 'name': 'HENDERSON, CHASE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 820, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 945 }, 'equipment': null, 'owner': null }, { 'nodeId': 1497, 'name': 'EDWARDS, KENNETH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 823, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 941 }, 'equipment': null, 'owner': null }, { 'nodeId': 1498, 'name': 'GREEN, DREW', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 823, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 943 }, 'equipment': null, 'owner': null }, { 'nodeId': 1499, 'name': 'HUDDLESTON, BENNY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2794, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 947 }, 'equipment': null, 'owner': null }, { 'nodeId': 1500, 'name': 'PARSLEY, MICHELLE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 825, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 951 }, 'equipment': null, 'owner': null }, { 'nodeId': 1501, 'name': 'HAWKINS, JOHNNIE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 826, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 944 }, 'equipment': null, 'owner': null }, { 'nodeId': 1502, 'name': 'SCOTT, HAZEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 827, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 249 }, 'equipment': null, 'owner': null }, { 'nodeId': 1503, 'name': 'HOPKINS, BARBARA', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 828, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 248 }, 'equipment': null, 'owner': null }, { 'nodeId': 1504, 'name': 'PARISH, WAYNE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 829, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 255 }, 'equipment': null, 'owner': null }, { 'nodeId': 1505, 'name': 'RAZER, MARK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 830, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 256 }, 'equipment': null, 'owner': null }, { 'nodeId': 1506, 'name': 'WILLIAMS, HAROLD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 831, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 258 }, 'equipment': null, 'owner': null }, { 'nodeId': 1507, 'name': 'LONG, COLE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 832, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 253 }, 'equipment': null, 'owner': null }, { 'nodeId': 1508, 'name': 'SHEPPARD, DAVID', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 832, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 257 }, 'equipment': null, 'owner': null }, { 'nodeId': 1509, 'name': 'GIBBENS, CHRIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 833, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 251 }, 'equipment': null, 'owner': null }, { 'nodeId': 1510, 'name': 'GLUECK, STEVE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 833, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 252 }, 'equipment': null, 'owner': null }, { 'nodeId': 1511, 'name': 'LOWE, ZACHARY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 834, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 254 }, 'equipment': null, 'owner': null }, { 'nodeId': 1512, 'name': 'GENTRY, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 835, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 268 }, 'equipment': null, 'owner': null }, { 'nodeId': 1513, 'name': 'MURPHY, STEPHEN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 836, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 262 }, 'equipment': null, 'owner': null }, { 'nodeId': 1514, 'name': 'DAVIES, CORY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 837, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 260 }, 'equipment': null, 'owner': null }, { 'nodeId': 1515, 'name': 'MULLEN, KEITH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 838, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 261 }, 'equipment': null, 'owner': null }, { 'nodeId': 1516, 'name': 'BANKS, CHARLES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 839, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 259 }, 'equipment': null, 'owner': null }, { 'nodeId': 1517, 'name': 'ROUSE, ERICK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 839, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 263 }, 'equipment': null, 'owner': null }, { 'nodeId': 1518, 'name': 'TAYLOR, CHRISTOPHER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 840, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 264 }, 'equipment': null, 'owner': null }, { 'nodeId': 1519, 'name': 'TAYLOR, KABE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 840, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 265 }, 'equipment': null, 'owner': null }, { 'nodeId': 1520, 'name': 'DEPRIEST, THOMAS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 841, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 267 }, 'equipment': null, 'owner': null }, { 'nodeId': 1521, 'name': 'SHARP, ROBERT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 843, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 273 }, 'equipment': null, 'owner': null }, { 'nodeId': 1522, 'name': 'MITCHELL, BOBBY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 844, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.093Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.093Z', 'userAccount': { 'userAccountId': 269 }, 'equipment': null, 'owner': null }, { 'nodeId': 1523, 'name': 'ROSS, STEVEN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 844, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 272 }, 'equipment': null, 'owner': null }, { 'nodeId': 1524, 'name': 'BRILEY, ADAM', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 845, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 266 }, 'equipment': null, 'owner': null }, { 'nodeId': 1525, 'name': 'NEEL, JERRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 845, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 271 }, 'equipment': null, 'owner': null }, { 'nodeId': 1526, 'name': 'MORRIS, JARED', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 846, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 270 }, 'equipment': null, 'owner': null }, { 'nodeId': 1527, 'name': 'HAWKINS, CURTIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 847, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 276 }, 'equipment': null, 'owner': null }, { 'nodeId': 1528, 'name': 'BROTHERS, RICKY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 848, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 274 }, 'equipment': null, 'owner': null }, { 'nodeId': 1529, 'name': 'RUSSELL, BRYAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 849, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 279 }, 'equipment': null, 'owner': null }, { 'nodeId': 1530, 'name': 'JOHNSON, BRAD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 850, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 277 }, 'equipment': null, 'owner': null }, { 'nodeId': 1531, 'name': 'MACE, CODY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 850, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 278 }, 'equipment': null, 'owner': null }, { 'nodeId': 1532, 'name': 'GEE, CHRIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 851, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 275 }, 'equipment': null, 'owner': null }, { 'nodeId': 1533, 'name': 'STEWART, REGINALD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 851, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 280 }, 'equipment': null, 'owner': null }, { 'nodeId': 1534, 'name': 'WILLIAMS, JASON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 852, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 281 }, 'equipment': null, 'owner': null }, { 'nodeId': 1535, 'name': 'MILLER, JARED', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2703, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 286 }, 'equipment': null, 'owner': null }, { 'nodeId': 1536, 'name': 'SHEPARD, BRODY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 854, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 290 }, 'equipment': null, 'owner': null }, { 'nodeId': 1537, 'name': 'GOODLOW, EARTHA', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 855, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 283 }, 'equipment': null, 'owner': null }, { 'nodeId': 1538, 'name': 'PETERSON, LINDA', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 855, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 288 }, 'equipment': null, 'owner': null }, { 'nodeId': 1539, 'name': 'CABLE, ED', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 857, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 282 }, 'equipment': null, 'owner': null }, { 'nodeId': 1540, 'name': 'JACKSON, GARY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 857, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 284 }, 'equipment': null, 'owner': null }, { 'nodeId': 1541, 'name': 'MARSHALL, VELON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 857, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 285 }, 'equipment': null, 'owner': null }, { 'nodeId': 1542, 'name': 'SHELTON, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 857, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 289 }, 'equipment': null, 'owner': null }, { 'nodeId': 1543, 'name': 'NEWCOMB, BOBBY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 858, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 287 }, 'equipment': null, 'owner': null }, { 'nodeId': 1544, 'name': 'ONEAL, SHAWN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 859, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 303 }, 'equipment': null, 'owner': null }, { 'nodeId': 1545, 'name': 'STRAWN, CAMERON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 860, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 307 }, 'equipment': null, 'owner': null }, { 'nodeId': 1546, 'name': 'RICHARDSON, BRETT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 861, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 305 }, 'equipment': null, 'owner': null }, { 'nodeId': 1547, 'name': 'DYE, DERRICK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 862, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 295 }, 'equipment': null, 'owner': null }, { 'nodeId': 1548, 'name': 'TATE, JUSTIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 863, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 308 }, 'equipment': null, 'owner': null }, { 'nodeId': 1549, 'name': 'JACOBS, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 864, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 298 }, 'equipment': null, 'owner': null }, { 'nodeId': 1550, 'name': 'GUTIERREZ, JESSE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 865, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 297 }, 'equipment': null, 'owner': null }, { 'nodeId': 1551, 'name': 'MITCHELL, AUSTIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 866, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 300 }, 'equipment': null, 'owner': null }, { 'nodeId': 1552, 'name': 'MITCHELL, CHARDRICK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 866, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 301 }, 'equipment': null, 'owner': null }, { 'nodeId': 1553, 'name': 'GRISSOM, TIMOTHY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 867, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 296 }, 'equipment': null, 'owner': null }, { 'nodeId': 1554, 'name': 'MUSGRAVES, JOHN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 867, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 302 }, 'equipment': null, 'owner': null }, { 'nodeId': 1555, 'name': 'DRAUGHN, EARL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 869, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 294 }, 'equipment': null, 'owner': null }, { 'nodeId': 1556, 'name': 'JOHNSON, KENNETH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 870, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 299 }, 'equipment': null, 'owner': null }, { 'nodeId': 1557, 'name': 'PANKEY, NOAH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 870, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 304 }, 'equipment': null, 'owner': null }, { 'nodeId': 1558, 'name': 'ROBINSON, RICKEY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 870, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 306 }, 'equipment': null, 'owner': null }, { 'nodeId': 1559, 'name': 'CORBETT, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2706, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 292 }, 'equipment': null, 'owner': null }, { 'nodeId': 1560, 'name': 'DAVIS, RICKEY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2704, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 293 }, 'equipment': null, 'owner': null }, { 'nodeId': 1561, 'name': 'TAYLOR, DENNIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 872, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 322 }, 'equipment': null, 'owner': null }, { 'nodeId': 1562, 'name': 'BRASSFIELD, AARON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 873, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 311 }, 'equipment': null, 'owner': null }, { 'nodeId': 1563, 'name': 'MANN, JACOB', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 875, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.094Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.094Z', 'userAccount': { 'userAccountId': 320 }, 'equipment': null, 'owner': null }, { 'nodeId': 1564, 'name': 'VASSAR, PHILLIP', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 876, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 323 }, 'equipment': null, 'owner': null }, { 'nodeId': 1565, 'name': 'BERRY, STEVE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 877, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 309 }, 'equipment': null, 'owner': null }, { 'nodeId': 1566, 'name': 'DAWSON, DEWAYNE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 878, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 314 }, 'equipment': null, 'owner': null }, { 'nodeId': 1567, 'name': 'HUGHES, JOHN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 879, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 318 }, 'equipment': null, 'owner': null }, { 'nodeId': 1568, 'name': 'DAVIS, RANDY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 880, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 313 }, 'equipment': null, 'owner': null }, { 'nodeId': 1569, 'name': 'FOWLER, ERIC', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 880, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 315 }, 'equipment': null, 'owner': null }, { 'nodeId': 1570, 'name': 'LANIER, KEITH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 880, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 319 }, 'equipment': null, 'owner': null }, { 'nodeId': 1571, 'name': 'WILKERSON, KEVIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 881, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 324 }, 'equipment': null, 'owner': null }, { 'nodeId': 1572, 'name': 'CUNNINGHAM, MATT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 882, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 312 }, 'equipment': null, 'owner': null }, { 'nodeId': 1573, 'name': 'BLUE, LESLIE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 883, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 310 }, 'equipment': null, 'owner': null }, { 'nodeId': 1574, 'name': 'FOWLER, TROY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 883, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 316 }, 'equipment': null, 'owner': null }, { 'nodeId': 1575, 'name': 'GRAY, DONALD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2708, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 317 }, 'equipment': null, 'owner': null }, { 'nodeId': 1576, 'name': 'SIMS, DAVID', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2707, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 321 }, 'equipment': null, 'owner': null }, { 'nodeId': 1577, 'name': 'ROBERTS, DANNY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 885, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 337 }, 'equipment': null, 'owner': null }, { 'nodeId': 1578, 'name': 'BOND, BENJAMIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 886, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 326 }, 'equipment': null, 'owner': null }, { 'nodeId': 1579, 'name': 'GILBOW, JOEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 887, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 330 }, 'equipment': null, 'owner': null }, { 'nodeId': 1580, 'name': 'MEADOR, JEFFERY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 888, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 335 }, 'equipment': null, 'owner': null }, { 'nodeId': 1581, 'name': 'GOTHARD, SCOTT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 889, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 331 }, 'equipment': null, 'owner': null }, { 'nodeId': 1582, 'name': 'SIMMONS, JASON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 890, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 339 }, 'equipment': null, 'owner': null }, { 'nodeId': 1583, 'name': 'SMITHWICK, DOUGLAS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 891, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 340 }, 'equipment': null, 'owner': null }, { 'nodeId': 1584, 'name': 'DAVIS, BRIAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 892, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 327 }, 'equipment': null, 'owner': null }, { 'nodeId': 1585, 'name': 'EVANS, KYLE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2710, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 328 }, 'equipment': null, 'owner': null }, { 'nodeId': 1586, 'name': 'HYMAS, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2710, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 332 }, 'equipment': null, 'owner': null }, { 'nodeId': 1587, 'name': 'SELVY, QUINCY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2710, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 338 }, 'equipment': null, 'owner': null }, { 'nodeId': 1588, 'name': 'FLOWERS, ERIC', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 894, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 329 }, 'equipment': null, 'owner': null }, { 'nodeId': 1589, 'name': 'LOVE, ROB', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 895, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 334 }, 'equipment': null, 'owner': null }, { 'nodeId': 1590, 'name': 'BABCOCK, ADAM', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 896, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 325 }, 'equipment': null, 'owner': null }, { 'nodeId': 1591, 'name': 'KILBREATH, LANCE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 896, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 333 }, 'equipment': null, 'owner': null }, { 'nodeId': 1592, 'name': 'NEWBERN, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2711, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 336 }, 'equipment': null, 'owner': null }, { 'nodeId': 1593, 'name': 'TOWERY, PAUL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2709, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 341 }, 'equipment': null, 'owner': null }, { 'nodeId': 1594, 'name': 'DAMRON, HARRELL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 898, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 346 }, 'equipment': null, 'owner': null }, { 'nodeId': 1595, 'name': 'WARREN, MARK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 899, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 358 }, 'equipment': null, 'owner': null }, { 'nodeId': 1596, 'name': 'STUBBLEFIELD, STEVEN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 900, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 354 }, 'equipment': null, 'owner': null }, { 'nodeId': 1597, 'name': 'BRENTS, KALEB', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 901, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 342 }, 'equipment': null, 'owner': null }, { 'nodeId': 1598, 'name': 'TOLSON, PAUL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 902, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 355 }, 'equipment': null, 'owner': null }, { 'nodeId': 1599, 'name': 'LEWIS, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 903, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 351 }, 'equipment': null, 'owner': null }, { 'nodeId': 1600, 'name': 'FORD, TAYLOR', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2713, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 348 }, 'equipment': null, 'owner': null }, { 'nodeId': 1601, 'name': 'TURNER, CARLOS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 905, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 356 }, 'equipment': null, 'owner': null }, { 'nodeId': 1602, 'name': 'BUTLER, CECIL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 906, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 343 }, 'equipment': null, 'owner': null }, { 'nodeId': 1603, 'name': 'HOLLIS, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 906, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 349 }, 'equipment': null, 'owner': null }, { 'nodeId': 1604, 'name': 'MILLER, ROBERT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 906, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 352 }, 'equipment': null, 'owner': null }, { 'nodeId': 1605, 'name': 'FLATNESS, DEREK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 907, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.095Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.095Z', 'userAccount': { 'userAccountId': 347 }, 'equipment': null, 'owner': null }, { 'nodeId': 1606, 'name': 'CATO, RONNIE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 908, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 344 }, 'equipment': null, 'owner': null }, { 'nodeId': 1607, 'name': 'COOPER, JERRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 909, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 345 }, 'equipment': null, 'owner': null }, { 'nodeId': 1608, 'name': 'WALKER, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 909, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 357 }, 'equipment': null, 'owner': null }, { 'nodeId': 1609, 'name': 'LARUE, ANTHONY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2714, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 350 }, 'equipment': null, 'owner': null }, { 'nodeId': 1610, 'name': 'RHODES, ROCKY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2712, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 353 }, 'equipment': null, 'owner': null }, { 'nodeId': 1611, 'name': 'KING, JACK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 911, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 507 }, 'equipment': null, 'owner': null }, { 'nodeId': 1612, 'name': 'BOGUE, KINLOCK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 912, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 506 }, 'equipment': null, 'owner': null }, { 'nodeId': 1613, 'name': 'MISNER, BILLY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 912, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 508 }, 'equipment': null, 'owner': null }, { 'nodeId': 1614, 'name': 'BINGHAM, GARRICK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 913, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 505 }, 'equipment': null, 'owner': null }, { 'nodeId': 1615, 'name': 'DEEDS, CHRISTOPHER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 914, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 512 }, 'equipment': null, 'owner': null }, { 'nodeId': 1616, 'name': 'NORRIS, SCOTT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 914, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 515 }, 'equipment': null, 'owner': null }, { 'nodeId': 1617, 'name': 'BURTON, JEREMY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 915, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 510 }, 'equipment': null, 'owner': null }, { 'nodeId': 1618, 'name': 'CROSS, PHILLIP', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 915, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 511 }, 'equipment': null, 'owner': null }, { 'nodeId': 1619, 'name': 'DEHART, STEVEN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 915, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 513 }, 'equipment': null, 'owner': null }, { 'nodeId': 1620, 'name': 'LEWIS, NATHANIAL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 915, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 514 }, 'equipment': null, 'owner': null }, { 'nodeId': 1621, 'name': 'SHOUP, TOMMY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 915, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 516 }, 'equipment': null, 'owner': null }, { 'nodeId': 1622, 'name': 'STEWARD, GARY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 915, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 517 }, 'equipment': null, 'owner': null }, { 'nodeId': 1623, 'name': 'GRIGGS, RYAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 916, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 521 }, 'equipment': null, 'owner': null }, { 'nodeId': 1624, 'name': 'JONES, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2756, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 527 }, 'equipment': null, 'owner': null }, { 'nodeId': 1625, 'name': 'KENNEDY, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 917, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 528 }, 'equipment': null, 'owner': null }, { 'nodeId': 1626, 'name': 'CHISM, LEON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 918, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 518 }, 'equipment': null, 'owner': null }, { 'nodeId': 1627, 'name': 'IVY, SCOTT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 919, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 524 }, 'equipment': null, 'owner': null }, { 'nodeId': 1628, 'name': 'LUTTRELL, BRUCE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 920, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 529 }, 'equipment': null, 'owner': null }, { 'nodeId': 1629, 'name': 'PRUETT, GARY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 920, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 531 }, 'equipment': null, 'owner': null }, { 'nodeId': 1630, 'name': 'SOWELL, DAVID', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 920, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 532 }, 'equipment': null, 'owner': null }, { 'nodeId': 1631, 'name': 'GARRETT, KENNETH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 921, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 519 }, 'equipment': null, 'owner': null }, { 'nodeId': 1632, 'name': 'GRAHAM, CHARLES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 921, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 1004 }, 'equipment': null, 'owner': null }, { 'nodeId': 1633, 'name': 'HOLT, DAVID', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 921, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 523 }, 'equipment': null, 'owner': null }, { 'nodeId': 1634, 'name': 'JOHNSON, CALISSE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 921, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 525 }, 'equipment': null, 'owner': null }, { 'nodeId': 1635, 'name': 'JOHNSON, WILLIAM', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 921, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 526 }, 'equipment': null, 'owner': null }, { 'nodeId': 1636, 'name': 'MCCALLIE, EDWARD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 921, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 530 }, 'equipment': null, 'owner': null }, { 'nodeId': 1637, 'name': 'PARISH, JACOB', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2757, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 545 }, 'equipment': null, 'owner': null }, { 'nodeId': 1638, 'name': 'TATE, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 921, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 533 }, 'equipment': null, 'owner': null }, { 'nodeId': 1639, 'name': 'WHITTED, JEREMY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 921, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 534 }, 'equipment': null, 'owner': null }, { 'nodeId': 1640, 'name': 'WYATT, BLAKE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 921, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 535 }, 'equipment': null, 'owner': null }, { 'nodeId': 1641, 'name': 'GRAY, DONNIE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 922, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 520 }, 'equipment': null, 'owner': null }, { 'nodeId': 1642, 'name': 'HADDOCK, KEITH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 922, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 522 }, 'equipment': null, 'owner': null }, { 'nodeId': 1643, 'name': 'COLEMAN, JOE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 923, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 536 }, 'equipment': null, 'owner': null }, { 'nodeId': 1644, 'name': 'WILLIAMS, MARIO', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2758, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 550 }, 'equipment': null, 'owner': null }, { 'nodeId': 1645, 'name': 'YATES, GEORGE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 923, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 551 }, 'equipment': null, 'owner': null }, { 'nodeId': 1646, 'name': 'CRANE, JASON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2757, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 537 }, 'equipment': null, 'owner': null }, { 'nodeId': 1647, 'name': 'JONES, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2757, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.096Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.096Z', 'userAccount': { 'userAccountId': 539 }, 'equipment': null, 'owner': null }, { 'nodeId': 1648, 'name': 'KENNON, BRANDON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2757, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 541 }, 'equipment': null, 'owner': null }, { 'nodeId': 1649, 'name': 'KNOWLTON, KENNETH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2757, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 542 }, 'equipment': null, 'owner': null }, { 'nodeId': 1650, 'name': 'KNUTH, GERALD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2757, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 543 }, 'equipment': null, 'owner': null }, { 'nodeId': 1651, 'name': 'MERRIWEATHER, JEFF', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2757, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 544 }, 'equipment': null, 'owner': null }, { 'nodeId': 1652, 'name': 'SHEPHERD, DAVID', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2757, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 546 }, 'equipment': null, 'owner': null }, { 'nodeId': 1653, 'name': 'VAUGHN, DANNY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2757, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 547 }, 'equipment': null, 'owner': null }, { 'nodeId': 1654, 'name': 'WHITLOCK, TODD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2757, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 548 }, 'equipment': null, 'owner': null }, { 'nodeId': 1655, 'name': 'WILLIAMS, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2757, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 549 }, 'equipment': null, 'owner': null }, { 'nodeId': 1656, 'name': 'CUNNINGHAM, MARK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 925, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 554 }, 'equipment': null, 'owner': null }, { 'nodeId': 1657, 'name': 'BEACH, TY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 926, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 552 }, 'equipment': null, 'owner': null }, { 'nodeId': 1658, 'name': 'BEAL, JESSE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 926, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 553 }, 'equipment': null, 'owner': null }, { 'nodeId': 1659, 'name': 'DRERUP, PHILLIP', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 926, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 555 }, 'equipment': null, 'owner': null }, { 'nodeId': 1660, 'name': 'GUTHRIE, RYAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 926, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 556 }, 'equipment': null, 'owner': null }, { 'nodeId': 1661, 'name': 'HAWKINS, DENNIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 926, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 557 }, 'equipment': null, 'owner': null }, { 'nodeId': 1662, 'name': 'HAWKINS, JEREMY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 926, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 558 }, 'equipment': null, 'owner': null }, { 'nodeId': 1663, 'name': 'PATTERSON, RYAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 926, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 559 }, 'equipment': null, 'owner': null }, { 'nodeId': 1664, 'name': 'RICHARDSON, WADE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 926, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 560 }, 'equipment': null, 'owner': null }, { 'nodeId': 1665, 'name': 'SUMMERS, JOEY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 926, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 561 }, 'equipment': null, 'owner': null }, { 'nodeId': 1666, 'name': 'YOUNG, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 926, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 563 }, 'equipment': null, 'owner': null }, { 'nodeId': 1667, 'name': 'WHITE, PHILLIP', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 927, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 964 }, 'equipment': null, 'owner': null }, { 'nodeId': 1668, 'name': 'GENTRY, CHARLES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 928, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 955 }, 'equipment': null, 'owner': null }, { 'nodeId': 1669, 'name': 'MCKELLEP, TODD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 929, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 960 }, 'equipment': null, 'owner': null }, { 'nodeId': 1670, 'name': 'HOBBS, JASON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 930, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 957 }, 'equipment': null, 'owner': null }, { 'nodeId': 1671, 'name': 'JONES, BRADLEY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 931, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 958 }, 'equipment': null, 'owner': null }, { 'nodeId': 1672, 'name': 'GABLE, RICK LEE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 932, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 954 }, 'equipment': null, 'owner': null }, { 'nodeId': 1673, 'name': 'SMOTHERS, SCOTTY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 932, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 963 }, 'equipment': null, 'owner': null }, { 'nodeId': 1674, 'name': 'WINBERRY, JOHN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 932, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 965 }, 'equipment': null, 'owner': null }, { 'nodeId': 1675, 'name': 'LACK, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 933, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 959 }, 'equipment': null, 'owner': null }, { 'nodeId': 1676, 'name': 'GUICE, ANDRE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 934, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 956 }, 'equipment': null, 'owner': null }, { 'nodeId': 1677, 'name': 'DRUMRIGHT, DUSTIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 935, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 953 }, 'equipment': null, 'owner': null }, { 'nodeId': 1678, 'name': 'OWENS, CHRISTOPHER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 935, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 961 }, 'equipment': null, 'owner': null }, { 'nodeId': 1679, 'name': 'PAYNE, JOSHUA', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 935, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 962 }, 'equipment': null, 'owner': null }, { 'nodeId': 1680, 'name': 'JACKSON, STEPHEN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 936, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 972 }, 'equipment': null, 'owner': null }, { 'nodeId': 1681, 'name': 'WOHL, DAVID', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 937, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 977 }, 'equipment': null, 'owner': null }, { 'nodeId': 1682, 'name': 'RIGGS, DEREK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 938, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 973 }, 'equipment': null, 'owner': null }, { 'nodeId': 1683, 'name': 'HAWKINS, JOHNNY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 940, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 970 }, 'equipment': null, 'owner': null }, { 'nodeId': 1684, 'name': 'ROBERTS, DANIEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 940, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 974 }, 'equipment': null, 'owner': null }, { 'nodeId': 1685, 'name': 'TILLEY, BRIAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 940, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 975 }, 'equipment': null, 'owner': null }, { 'nodeId': 1686, 'name': 'AULT, CHARLES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 941, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 966 }, 'equipment': null, 'owner': null }, { 'nodeId': 1687, 'name': 'HAWKINS, DARREN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2795, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 969 }, 'equipment': null, 'owner': null }, { 'nodeId': 1688, 'name': 'COHN, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 943, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.097Z', 'userAccount': { 'userAccountId': 967 }, 'equipment': null, 'owner': null }, { 'nodeId': 1689, 'name': 'ELLIS, TODD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 943, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 968 }, 'equipment': null, 'owner': null }, { 'nodeId': 1690, 'name': 'WAGSTER, JARED', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 943, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 976 }, 'equipment': null, 'owner': null }, { 'nodeId': 1691, 'name': 'PRY, CRAIG', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 944, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 993 }, 'equipment': null, 'owner': null }, { 'nodeId': 1692, 'name': 'THOMPSON, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 945, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 996 }, 'equipment': null, 'owner': null }, { 'nodeId': 1693, 'name': 'KINCAID, DAVID', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 946, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 988 }, 'equipment': null, 'owner': null }, { 'nodeId': 1694, 'name': 'STACY, DOUGLAS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2705, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 291 }, 'equipment': null, 'owner': null }, { 'nodeId': 1695, 'name': 'CARTER, JACOB', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 947, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 981 }, 'equipment': null, 'owner': null }, { 'nodeId': 1696, 'name': 'CLARK, NATHAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 947, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 982 }, 'equipment': null, 'owner': null }, { 'nodeId': 1697, 'name': 'GANUS, JORDAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 947, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 983 }, 'equipment': null, 'owner': null }, { 'nodeId': 1698, 'name': 'INGRAM, SCOTT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 947, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 987 }, 'equipment': null, 'owner': null }, { 'nodeId': 1699, 'name': 'LACER, KODY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 947, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 989 }, 'equipment': null, 'owner': null }, { 'nodeId': 1700, 'name': 'LARK, GREGORY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 947, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 990 }, 'equipment': null, 'owner': null }, { 'nodeId': 1701, 'name': 'MONCADA, ERNESTO', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 947, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 991 }, 'equipment': null, 'owner': null }, { 'nodeId': 1702, 'name': 'ONEAL, ALAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 947, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 992 }, 'equipment': null, 'owner': null }, { 'nodeId': 1703, 'name': 'TUCKER, ADAM', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 947, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 997 }, 'equipment': null, 'owner': null }, { 'nodeId': 1704, 'name': 'TURNER, NEAL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 947, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 998 }, 'equipment': null, 'owner': null }, { 'nodeId': 1705, 'name': 'STONE, JEFFERY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 948, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 995 }, 'equipment': null, 'owner': null }, { 'nodeId': 1706, 'name': 'GRIBBLE, TIMOTHY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 950, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 985 }, 'equipment': null, 'owner': null }, { 'nodeId': 1707, 'name': 'HOHN, HANS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 950, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 986 }, 'equipment': null, 'owner': null }, { 'nodeId': 1708, 'name': 'RILEY, DONALD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 950, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 994 }, 'equipment': null, 'owner': null }, { 'nodeId': 1709, 'name': 'BRYANT, ROBERT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 951, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 980 }, 'equipment': null, 'owner': null }, { 'nodeId': 1710, 'name': 'GILMER, JIM', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 952, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 984 }, 'equipment': null, 'owner': null }, { 'nodeId': 1711, 'name': 'BARNES, ANDREW', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 953, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 978 }, 'equipment': null, 'owner': null }, { 'nodeId': 1712, 'name': 'BROOKS, TYLER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 954, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 979 }, 'equipment': null, 'owner': null }, { 'nodeId': 1713, 'name': 'WILLIAMSON, PAUL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 955, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 1019 }, 'equipment': null, 'owner': null }, { 'nodeId': 1714, 'name': 'POWELL, RICKY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 956, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 1014 }, 'equipment': null, 'owner': null }, { 'nodeId': 1715, 'name': 'AUSTIN, JEFFERY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 958, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 1168 }, 'equipment': null, 'owner': null }, { 'nodeId': 1716, 'name': 'BARNETTE, CHRISTOPHER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 958, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 999 }, 'equipment': null, 'owner': null }, { 'nodeId': 1717, 'name': 'CRAWFORD, LOGAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 958, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 1000 }, 'equipment': null, 'owner': null }, { 'nodeId': 1718, 'name': 'FOWLKES, KEITH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 958, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 1002 }, 'equipment': null, 'owner': null }, { 'nodeId': 1719, 'name': 'HESTER, HEATH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 958, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 1006 }, 'equipment': null, 'owner': null }, { 'nodeId': 1720, 'name': 'LEWELLYNG, CHRIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 958, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 1007 }, 'equipment': null, 'owner': null }, { 'nodeId': 1721, 'name': 'MCMELLON, ADAM', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 958, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 1011 }, 'equipment': null, 'owner': null }, { 'nodeId': 1722, 'name': 'VANAUSDALL, LUKE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 958, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 1015 }, 'equipment': null, 'owner': null }, { 'nodeId': 1723, 'name': 'WHATLEY, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 958, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.098Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.098Z', 'userAccount': { 'userAccountId': 1017 }, 'equipment': null, 'owner': null }, { 'nodeId': 1724, 'name': 'WILLIAMS, TREY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 958, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 1018 }, 'equipment': null, 'owner': null }, { 'nodeId': 1725, 'name': 'WILSON, MEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 958, 'rank': 11, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 1020 }, 'equipment': null, 'owner': null }, { 'nodeId': 1726, 'name': 'FRUHLING, MERLE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 959, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 1003 }, 'equipment': null, 'owner': null }, { 'nodeId': 1727, 'name': 'MISNER, MARK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 960, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 1012 }, 'equipment': null, 'owner': null }, { 'nodeId': 1728, 'name': 'LEWIS, CHRISTOPHER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 961, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 1008 }, 'equipment': null, 'owner': null }, { 'nodeId': 1729, 'name': 'POOLE, TERRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 961, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 1013 }, 'equipment': null, 'owner': null }, { 'nodeId': 1730, 'name': 'LEWIS, HAROLD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 962, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 1009 }, 'equipment': null, 'owner': null }, { 'nodeId': 1731, 'name': 'CRAWFORD, MIKLE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 963, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 1001 }, 'equipment': null, 'owner': null }, { 'nodeId': 1732, 'name': 'HENRY, CARL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 964, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 1005 }, 'equipment': null, 'owner': null }, { 'nodeId': 1733, 'name': 'WALLACE, JEFFREY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 965, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 1016 }, 'equipment': null, 'owner': null }, { 'nodeId': 1734, 'name': 'TOPALIAN, LEON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 977, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 565 }, 'equipment': null, 'owner': null }, { 'nodeId': 1735, 'name': 'PREVOST, KEITH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 978, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 564 }, 'equipment': null, 'owner': null }, { 'nodeId': 1736, 'name': 'KAZYAK, JOHN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 979, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 566 }, 'equipment': null, 'owner': null }, { 'nodeId': 1737, 'name': 'CLARK, SHEA', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 980, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 568 }, 'equipment': null, 'owner': null }, { 'nodeId': 1738, 'name': 'FOSTER, ABBIE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 980, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 570 }, 'equipment': null, 'owner': null }, { 'nodeId': 1739, 'name': 'STRICKLAND, PATRISE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 980, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 576 }, 'equipment': null, 'owner': null }, { 'nodeId': 1740, 'name': 'ABRAM, JERRICA', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2762, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 567 }, 'equipment': null, 'owner': null }, { 'nodeId': 1741, 'name': 'DORRIS, KAREN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2762, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 569 }, 'equipment': null, 'owner': null }, { 'nodeId': 1742, 'name': 'JEFFERSON, KATHY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2762, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 573 }, 'equipment': null, 'owner': null }, { 'nodeId': 1743, 'name': 'PRITCHARD, HEATHER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2762, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 574 }, 'equipment': null, 'owner': null }, { 'nodeId': 1744, 'name': 'SPILLER, LAKRISTEN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2762, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 575 }, 'equipment': null, 'owner': null }, { 'nodeId': 1745, 'name': 'ZIELINSKI, KIM', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2762, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 577 }, 'equipment': null, 'owner': null }, { 'nodeId': 1746, 'name': 'GRIBBLE, HALEY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2762, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 572 }, 'equipment': null, 'owner': null }, { 'nodeId': 1747, 'name': 'SYKES, MARK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 984, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 580 }, 'equipment': null, 'owner': null }, { 'nodeId': 1748, 'name': 'SNOW, KEVIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 985, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 578 }, 'equipment': null, 'owner': null }, { 'nodeId': 1749, 'name': 'STOCKMAN, AMANDA', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2763, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 579 }, 'equipment': null, 'owner': null }, { 'nodeId': 1750, 'name': 'CRONE, CHRIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 987, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 668 }, 'equipment': null, 'owner': null }, { 'nodeId': 1751, 'name': 'BARRIOS, JUSTIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 988, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 667 }, 'equipment': null, 'owner': null }, { 'nodeId': 1752, 'name': 'NORRIS, CLAYTON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 988, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 669 }, 'equipment': null, 'owner': null }, { 'nodeId': 1753, 'name': 'VARADACHARI, NISHANT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2779, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 671 }, 'equipment': null, 'owner': null }, { 'nodeId': 1754, 'name': 'YORK, SAMUEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 988, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 672 }, 'equipment': null, 'owner': null }, { 'nodeId': 1755, 'name': 'WILLIAMS, LEN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 989, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 685 }, 'equipment': null, 'owner': null }, { 'nodeId': 1756, 'name': 'CHURCHWELL, TAMMY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 990, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 683 }, 'equipment': null, 'owner': null }, { 'nodeId': 1757, 'name': 'HOOKS, GWEN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 990, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 684 }, 'equipment': null, 'owner': null }, { 'nodeId': 1758, 'name': 'HAYNES, JUDY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 991, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 686 }, 'equipment': null, 'owner': null }, { 'nodeId': 1759, 'name': 'PEARSON, JACKIE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 992, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 687 }, 'equipment': null, 'owner': null }, { 'nodeId': 1760, 'name': 'STOKLEY, JESSICA', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 993, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 688 }, 'equipment': null, 'owner': null }, { 'nodeId': 1761, 'name': 'CARTER, JASON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 994, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 690 }, 'equipment': null, 'owner': null }, { 'nodeId': 1762, 'name': 'BAUGUS, JODY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 995, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 689 }, 'equipment': null, 'owner': null }, { 'nodeId': 1763, 'name': 'HUGHES, ANGIE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 995, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 693 }, 'equipment': null, 'owner': null }, { 'nodeId': 1764, 'name': 'NICHOLS, KASHALA', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 995, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 694 }, 'equipment': null, 'owner': null }, { 'nodeId': 1765, 'name': 'DEMAREE, SAM', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 996, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 691 }, 'equipment': null, 'owner': null }, { 'nodeId': 1766, 'name': 'HARDIN, TONY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 996, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.099Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.099Z', 'userAccount': { 'userAccountId': 692 }, 'equipment': null, 'owner': null }, { 'nodeId': 1767, 'name': 'SMITH, TOM', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 996, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 695 }, 'equipment': null, 'owner': null }, { 'nodeId': 1768, 'name': 'STRICKLAND, SCOTT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 996, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 696 }, 'equipment': null, 'owner': null }, { 'nodeId': 1769, 'name': 'WOESSNER, MARILYN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 996, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 697 }, 'equipment': null, 'owner': null }, { 'nodeId': 1770, 'name': 'DESPAIN, ROBERT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 997, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 700 }, 'equipment': null, 'owner': null }, { 'nodeId': 1771, 'name': 'CARMICHAEL, CHARLOTTE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2780, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 698 }, 'equipment': null, 'owner': null }, { 'nodeId': 1772, 'name': 'DAVIS, JEREMY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2782, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 699 }, 'equipment': null, 'owner': null }, { 'nodeId': 1773, 'name': 'FARROW, GAIL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2782, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 701 }, 'equipment': null, 'owner': null }, { 'nodeId': 1774, 'name': 'HOWARD, NATHAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2782, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 702 }, 'equipment': null, 'owner': null }, { 'nodeId': 1775, 'name': 'ROWLAND, AARON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2782, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 703 }, 'equipment': null, 'owner': null }, { 'nodeId': 1776, 'name': 'WELLS, KIRK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2782, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 705 }, 'equipment': null, 'owner': null }, { 'nodeId': 1777, 'name': 'TAYLOR, GINA', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1000, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 704 }, 'equipment': null, 'owner': null }, { 'nodeId': 1778, 'name': 'LOWE, BILL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1001, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 706 }, 'equipment': null, 'owner': null }, { 'nodeId': 1779, 'name': 'LOWE, BRIAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1002, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 707 }, 'equipment': null, 'owner': null }, { 'nodeId': 1780, 'name': 'BREWER, RYAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1004, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 709 }, 'equipment': null, 'owner': null }, { 'nodeId': 1781, 'name': 'BAUDENDISTEL, LATOSHA', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1005, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 708 }, 'equipment': null, 'owner': null }, { 'nodeId': 1782, 'name': 'PRUETT, JASON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2778, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 670 }, 'equipment': null, 'owner': null }, { 'nodeId': 1783, 'name': 'GALE, MEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1009, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 602 }, 'equipment': null, 'owner': null }, { 'nodeId': 1784, 'name': 'ANDERSON, KENDALL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1010, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 597 }, 'equipment': null, 'owner': null }, { 'nodeId': 1785, 'name': 'BAILEY, JUSTIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1010, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 598 }, 'equipment': null, 'owner': null }, { 'nodeId': 1786, 'name': 'DORMER, DUSTIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1010, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 599 }, 'equipment': null, 'owner': null }, { 'nodeId': 1787, 'name': 'DUNN, EMMETT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1010, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 600 }, 'equipment': null, 'owner': null }, { 'nodeId': 1788, 'name': 'FORSYTHE, STEPHEN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1010, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 601 }, 'equipment': null, 'owner': null }, { 'nodeId': 1789, 'name': 'RAPER, JOSHUA', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1010, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 603 }, 'equipment': null, 'owner': null }, { 'nodeId': 1790, 'name': 'THOMAS, BENJAMIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1010, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 604 }, 'equipment': null, 'owner': null }, { 'nodeId': 1791, 'name': 'BURTON, GREGORY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1011, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 605 }, 'equipment': null, 'owner': null }, { 'nodeId': 1792, 'name': 'DECKER, TONYA', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1012, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 606 }, 'equipment': null, 'owner': null }, { 'nodeId': 1793, 'name': 'DIGGES, DUSTIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1012, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 607 }, 'equipment': null, 'owner': null }, { 'nodeId': 1794, 'name': 'GONZALEZ, ADOLFO', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1012, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 608 }, 'equipment': null, 'owner': null }, { 'nodeId': 1795, 'name': 'GONZALEZ, HEBER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1012, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 609 }, 'equipment': null, 'owner': null }, { 'nodeId': 1796, 'name': 'LINDSEY, CHRISTOPHER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1012, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 1329 }, 'equipment': null, 'owner': null }, { 'nodeId': 1797, 'name': 'NWISI, BRUNO', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1012, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 610 }, 'equipment': null, 'owner': null }, { 'nodeId': 1798, 'name': 'ROGERS, CHARLES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1012, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 611 }, 'equipment': null, 'owner': null }, { 'nodeId': 1799, 'name': 'STONEBURNER, HERMAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1012, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 612 }, 'equipment': null, 'owner': null }, { 'nodeId': 1800, 'name': 'BARBEE, WARREN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1013, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 613 }, 'equipment': null, 'owner': null }, { 'nodeId': 1801, 'name': 'BREWER, JARED', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1014, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 614 }, 'equipment': null, 'owner': null }, { 'nodeId': 1802, 'name': 'DIXON, DANIEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1014, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 1322 }, 'equipment': null, 'owner': null }, { 'nodeId': 1803, 'name': 'FLIPPO, BRANDON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1014, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 615 }, 'equipment': null, 'owner': null }, { 'nodeId': 1804, 'name': 'JAUNES, RAYSEAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1014, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 1323 }, 'equipment': null, 'owner': null }, { 'nodeId': 1805, 'name': 'JOHNSON, PATRICK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1014, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 616 }, 'equipment': null, 'owner': null }, { 'nodeId': 1806, 'name': 'KIRK, TIMOTHY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1014, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 617 }, 'equipment': null, 'owner': null }, { 'nodeId': 1807, 'name': 'LIDDELL, SMITH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1014, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.100Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.100Z', 'userAccount': { 'userAccountId': 618 }, 'equipment': null, 'owner': null }, { 'nodeId': 1808, 'name': 'WESTMORLAN, BRETT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1014, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 619 }, 'equipment': null, 'owner': null }, { 'nodeId': 1809, 'name': 'WOODRUFF, AARON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1014, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 620 }, 'equipment': null, 'owner': null }, { 'nodeId': 1810, 'name': 'WASHINGTON, VEOTIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1015, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 628 }, 'equipment': null, 'owner': null }, { 'nodeId': 1811, 'name': 'ALDRIDGE, JIMMY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1016, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 1321 }, 'equipment': null, 'owner': null }, { 'nodeId': 1812, 'name': 'ALLEN, TRACY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1016, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 621 }, 'equipment': null, 'owner': null }, { 'nodeId': 1813, 'name': 'BROWN, MATTHEW', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1016, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 622 }, 'equipment': null, 'owner': null }, { 'nodeId': 1814, 'name': 'BROWN, ROBERT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1016, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 623 }, 'equipment': null, 'owner': null }, { 'nodeId': 1815, 'name': 'HARRIS, ROBERT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1016, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 624 }, 'equipment': null, 'owner': null }, { 'nodeId': 1816, 'name': 'HUFFMAN, RYAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1016, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 625 }, 'equipment': null, 'owner': null }, { 'nodeId': 1817, 'name': 'RAY, JOHN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1016, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 626 }, 'equipment': null, 'owner': null }, { 'nodeId': 1818, 'name': 'RHODES, KENTRELL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1016, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 627 }, 'equipment': null, 'owner': null }, { 'nodeId': 1819, 'name': 'WEBSTER, HENRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1016, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 629 }, 'equipment': null, 'owner': null }, { 'nodeId': 1820, 'name': 'MOORE, BRENT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2768, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 634 }, 'equipment': null, 'owner': null }, { 'nodeId': 1821, 'name': 'RHODES, DEBBIE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1018, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 636 }, 'equipment': null, 'owner': null }, { 'nodeId': 1822, 'name': 'ARCHIBALD, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2767, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 630 }, 'equipment': null, 'owner': null }, { 'nodeId': 1823, 'name': 'FOSTER, CLINTON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2767, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 631 }, 'equipment': null, 'owner': null }, { 'nodeId': 1824, 'name': 'HOLMQUIST, ALLEN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2767, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 632 }, 'equipment': null, 'owner': null }, { 'nodeId': 1825, 'name': 'KUMAR, ABHISHEK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2767, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 633 }, 'equipment': null, 'owner': null }, { 'nodeId': 1826, 'name': 'RETTIG, ROGER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2767, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 635 }, 'equipment': null, 'owner': null }, { 'nodeId': 1827, 'name': 'SCHOEN, JIM', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2767, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 637 }, 'equipment': null, 'owner': null }, { 'nodeId': 1828, 'name': 'WELCH, EMILY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2767, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 639 }, 'equipment': null, 'owner': null }, { 'nodeId': 1829, 'name': 'WHITAKER, FRANKLIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2767, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 640 }, 'equipment': null, 'owner': null }, { 'nodeId': 1830, 'name': 'SANFORD, KEVIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1020, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 642 }, 'equipment': null, 'owner': null }, { 'nodeId': 1831, 'name': 'TIMMS, CURTIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1020, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 643 }, 'equipment': null, 'owner': null }, { 'nodeId': 1832, 'name': 'LU, EVAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1021, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 641 }, 'equipment': null, 'owner': null }, { 'nodeId': 1833, 'name': 'PENNELL, GARY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1022, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 596 }, 'equipment': null, 'owner': null }, { 'nodeId': 1834, 'name': 'BENSON, PETER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1024, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 589 }, 'equipment': null, 'owner': null }, { 'nodeId': 1835, 'name': 'DRYDEN, LEONARD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1024, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 590 }, 'equipment': null, 'owner': null }, { 'nodeId': 1836, 'name': 'OLSON, MATTHEW', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1024, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 591 }, 'equipment': null, 'owner': null }, { 'nodeId': 1837, 'name': 'QUICK, MIKE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1024, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 592 }, 'equipment': null, 'owner': null }, { 'nodeId': 1838, 'name': 'TUCKER, PAT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2765, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 595 }, 'equipment': null, 'owner': null }, { 'nodeId': 1839, 'name': 'KIDD, BRYAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1026, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 593 }, 'equipment': null, 'owner': null }, { 'nodeId': 1840, 'name': 'MCGUIRE, TYLER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1026, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 594 }, 'equipment': null, 'owner': null }, { 'nodeId': 1841, 'name': 'SOUTHARD, STEVE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1028, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 359 }, 'equipment': null, 'owner': null }, { 'nodeId': 1842, 'name': 'HUTTON, MARK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2750, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 481 }, 'equipment': null, 'owner': null }, { 'nodeId': 1843, 'name': 'KENNON, JEFF', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2752, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 482 }, 'equipment': null, 'owner': null }, { 'nodeId': 1844, 'name': 'LONG, ROCKY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2751, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 483 }, 'equipment': null, 'owner': null }, { 'nodeId': 1845, 'name': 'HARRIS, TIMOTHY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2715, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 363 }, 'equipment': null, 'owner': null }, { 'nodeId': 1846, 'name': 'COLE, JIMMY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2716, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 361 }, 'equipment': null, 'owner': null }, { 'nodeId': 1847, 'name': 'PETERS, JEFF', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2716, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 366 }, 'equipment': null, 'owner': null }, { 'nodeId': 1848, 'name': 'FREEMAN, JOSHUA', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1032, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 362 }, 'equipment': null, 'owner': null }, { 'nodeId': 1849, 'name': 'KENDRICK, DANIEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1032, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 365 }, 'equipment': null, 'owner': null }, { 'nodeId': 1850, 'name': 'RINKS, NICHOLAS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1032, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 368 }, 'equipment': null, 'owner': null }, { 'nodeId': 1851, 'name': 'SHARP, CHRISTOPHER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1032, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.101Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.101Z', 'userAccount': { 'userAccountId': 369 }, 'equipment': null, 'owner': null }, { 'nodeId': 1852, 'name': 'STRINGER, KEVONTE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1032, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 370 }, 'equipment': null, 'owner': null }, { 'nodeId': 1853, 'name': 'REDMAN, BRANDON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2717, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 367 }, 'equipment': null, 'owner': null }, { 'nodeId': 1854, 'name': 'WEBB, BRYAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2717, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 371 }, 'equipment': null, 'owner': null }, { 'nodeId': 1855, 'name': 'JULIAN, MIKE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1034, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 364 }, 'equipment': null, 'owner': null }, { 'nodeId': 1856, 'name': 'HUMPHREY, DAVID', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2719, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 377 }, 'equipment': null, 'owner': null }, { 'nodeId': 1857, 'name': 'NORRIS, ZACHARY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1036, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 475 }, 'equipment': null, 'owner': null }, { 'nodeId': 1858, 'name': 'PRITCHARD, JEFFERY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2723, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 379 }, 'equipment': null, 'owner': null }, { 'nodeId': 1859, 'name': 'BAKER, JONATHAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1037, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 372 }, 'equipment': null, 'owner': null }, { 'nodeId': 1860, 'name': 'GATLIN, JACOB', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1037, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 374 }, 'equipment': null, 'owner': null }, { 'nodeId': 1861, 'name': 'GRIGGS, BEAU', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1037, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 375 }, 'equipment': null, 'owner': null }, { 'nodeId': 1862, 'name': 'SHEARIN, HARRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1037, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 380 }, 'equipment': null, 'owner': null }, { 'nodeId': 1863, 'name': 'SMOTHERS, JOSHUA', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1037, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 381 }, 'equipment': null, 'owner': null }, { 'nodeId': 1864, 'name': 'HENRY, CASEY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2721, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 376 }, 'equipment': null, 'owner': null }, { 'nodeId': 1865, 'name': 'MCGEHEE, JAVION', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2721, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 378 }, 'equipment': null, 'owner': null }, { 'nodeId': 1866, 'name': 'FLEMING, BO', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1039, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 373 }, 'equipment': null, 'owner': null }, { 'nodeId': 1867, 'name': 'TALLEY, DARRELL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2720, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 390 }, 'equipment': null, 'owner': null }, { 'nodeId': 1868, 'name': 'ARMSTRONG, CHRIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2722, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 382 }, 'equipment': null, 'owner': null }, { 'nodeId': 1869, 'name': 'JACKSON, ANTHONY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2722, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 387 }, 'equipment': null, 'owner': null }, { 'nodeId': 1870, 'name': 'TRIBLE, JERRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2722, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 391 }, 'equipment': null, 'owner': null }, { 'nodeId': 1871, 'name': 'HOLMES, GARY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1042, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 385 }, 'equipment': null, 'owner': null }, { 'nodeId': 1872, 'name': 'HONNOLL, MATTHEW', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1042, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 386 }, 'equipment': null, 'owner': null }, { 'nodeId': 1873, 'name': 'STOVALL, JOSHUA', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1042, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 389 }, 'equipment': null, 'owner': null }, { 'nodeId': 1874, 'name': 'HANCOCK, SHAWN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2724, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 384 }, 'equipment': null, 'owner': null }, { 'nodeId': 1875, 'name': 'SIMPSON, CHRISTOPHER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2724, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 388 }, 'equipment': null, 'owner': null }, { 'nodeId': 1876, 'name': 'DUCLOS, TRAVIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1044, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 383 }, 'equipment': null, 'owner': null }, { 'nodeId': 1877, 'name': 'TRAPP, JOSHUA', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2725, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 401 }, 'equipment': null, 'owner': null }, { 'nodeId': 1878, 'name': 'BEASLEY, NICHOLAS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2726, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 393 }, 'equipment': null, 'owner': null }, { 'nodeId': 1879, 'name': 'MCCULLOCH, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2726, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 397 }, 'equipment': null, 'owner': null }, { 'nodeId': 1880, 'name': 'STONE, TIMOTHY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2726, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 400 }, 'equipment': null, 'owner': null }, { 'nodeId': 1881, 'name': 'ANDERSON, MARCUS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1047, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.102Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.102Z', 'userAccount': { 'userAccountId': 392 }, 'equipment': null, 'owner': null }, { 'nodeId': 1882, 'name': 'HOUSE, KEITH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1047, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.108Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.108Z', 'userAccount': { 'userAccountId': 396 }, 'equipment': null, 'owner': null }, { 'nodeId': 1883, 'name': 'NEEDHAM, ANTHONY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2729, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.108Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.108Z', 'userAccount': { 'userAccountId': 413 }, 'equipment': null, 'owner': null }, { 'nodeId': 1884, 'name': 'POE, JOSEPH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1047, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.108Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.108Z', 'userAccount': { 'userAccountId': 398 }, 'equipment': null, 'owner': null }, { 'nodeId': 1885, 'name': 'ROLLAND, DEREK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1047, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.108Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.108Z', 'userAccount': { 'userAccountId': 399 }, 'equipment': null, 'owner': null }, { 'nodeId': 1886, 'name': 'WASHINGTON, DONTREL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1047, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.108Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.108Z', 'userAccount': { 'userAccountId': 402 }, 'equipment': null, 'owner': null }, { 'nodeId': 1887, 'name': 'GILLEAN, MATTHEW', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2727, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.108Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.108Z', 'userAccount': { 'userAccountId': 395 }, 'equipment': null, 'owner': null }, { 'nodeId': 1888, 'name': 'BETTS, CHARLES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1049, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.108Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.108Z', 'userAccount': { 'userAccountId': 394 }, 'equipment': null, 'owner': null }, { 'nodeId': 1889, 'name': 'HOUART, JOHN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2728, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.108Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.108Z', 'userAccount': { 'userAccountId': 408 }, 'equipment': null, 'owner': null }, { 'nodeId': 1890, 'name': 'CRAWFORD, MITCH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2732, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.108Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.108Z', 'userAccount': { 'userAccountId': 406 }, 'equipment': null, 'owner': null }, { 'nodeId': 1891, 'name': 'GRICE, GARY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2732, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.108Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.108Z', 'userAccount': { 'userAccountId': 407 }, 'equipment': null, 'owner': null }, { 'nodeId': 1892, 'name': 'JOHNSON, CURTIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2732, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.108Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.108Z', 'userAccount': { 'userAccountId': 409 }, 'equipment': null, 'owner': null }, { 'nodeId': 1893, 'name': 'LARUE, CHRISTOPHER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2732, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.108Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.108Z', 'userAccount': { 'userAccountId': 410 }, 'equipment': null, 'owner': null }, { 'nodeId': 1894, 'name': 'MCCAIN, SHANG', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2732, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.108Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.108Z', 'userAccount': { 'userAccountId': 411 }, 'equipment': null, 'owner': null }, { 'nodeId': 1895, 'name': 'NASH, ELDAIRO', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2732, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.108Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.108Z', 'userAccount': { 'userAccountId': 412 }, 'equipment': null, 'owner': null }, { 'nodeId': 1896, 'name': 'PRITCHETT, DAVID', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2732, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.108Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.108Z', 'userAccount': { 'userAccountId': 414 }, 'equipment': null, 'owner': null }, { 'nodeId': 1897, 'name': 'ROFE, GEORGE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2732, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.108Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.108Z', 'userAccount': { 'userAccountId': 415 }, 'equipment': null, 'owner': null }, { 'nodeId': 1898, 'name': 'ROUNSAVILLE, HUNTER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2729, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.108Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.108Z', 'userAccount': { 'userAccountId': 416 }, 'equipment': null, 'owner': null }, { 'nodeId': 1899, 'name': 'SALTZMAN, JASON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2732, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.108Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.108Z', 'userAccount': { 'userAccountId': 417 }, 'equipment': null, 'owner': null }, { 'nodeId': 1900, 'name': 'SPICER, DANNY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1051, 'rank': 11, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.108Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.108Z', 'userAccount': { 'userAccountId': 471 }, 'equipment': null, 'owner': null }, { 'nodeId': 1901, 'name': 'SULLINS, PAUL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2732, 'rank': 12, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.108Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.108Z', 'userAccount': { 'userAccountId': 418 }, 'equipment': null, 'owner': null }, { 'nodeId': 1902, 'name': 'TRINIDAD, TIMOTHY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2736, 'rank': 13, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.108Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.108Z', 'userAccount': { 'userAccountId': 419 }, 'equipment': null, 'owner': null }, { 'nodeId': 1903, 'name': 'APPLE, LLOYD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2730, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 403 }, 'equipment': null, 'owner': null }, { 'nodeId': 1904, 'name': 'BROWN, JOHNNY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2731, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 405 }, 'equipment': null, 'owner': null }, { 'nodeId': 1905, 'name': 'BARNES, ALFRED', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1054, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 404 }, 'equipment': null, 'owner': null }, { 'nodeId': 1906, 'name': 'CHAMPION, JOSEPH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2733, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 423 }, 'equipment': null, 'owner': null }, { 'nodeId': 1907, 'name': 'BELL, MATTHEW', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2736, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 421 }, 'equipment': null, 'owner': null }, { 'nodeId': 1908, 'name': 'BRUMLEY, PRESTON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2736, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 422 }, 'equipment': null, 'owner': null }, { 'nodeId': 1909, 'name': 'DEERE, ANDREW', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2736, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 425 }, 'equipment': null, 'owner': null }, { 'nodeId': 1910, 'name': 'DILL, ORAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1056, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 473 }, 'equipment': null, 'owner': null }, { 'nodeId': 1911, 'name': 'FAULKNER, JONATHAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2736, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 426 }, 'equipment': null, 'owner': null }, { 'nodeId': 1912, 'name': 'HOWELL, ERIC', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2736, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 427 }, 'equipment': null, 'owner': null }, { 'nodeId': 1913, 'name': 'MILLER, RAYMOND', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2736, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 429 }, 'equipment': null, 'owner': null }, { 'nodeId': 1914, 'name': 'MULLINS, JEREMY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2736, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 430 }, 'equipment': null, 'owner': null }, { 'nodeId': 1915, 'name': 'RINKINES, JONATHAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2736, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 431 }, 'equipment': null, 'owner': null }, { 'nodeId': 1916, 'name': 'SHELTON, NICHOLAS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2736, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 432 }, 'equipment': null, 'owner': null }, { 'nodeId': 1917, 'name': 'STONE, CHRISTOPHER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2736, 'rank': 11, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 433 }, 'equipment': null, 'owner': null }, { 'nodeId': 1918, 'name': 'BAKER, BARRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2734, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 420 }, 'equipment': null, 'owner': null }, { 'nodeId': 1919, 'name': 'LLOYD, PATRICK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2735, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 428 }, 'equipment': null, 'owner': null }, { 'nodeId': 1920, 'name': 'CROSSNO, BRIAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1059, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 424 }, 'equipment': null, 'owner': null }, { 'nodeId': 1921, 'name': 'CATER, TIMOTHY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2737, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 434 }, 'equipment': null, 'owner': null }, { 'nodeId': 1922, 'name': 'CRAWFORD, RICKIE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2740, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 435 }, 'equipment': null, 'owner': null }, { 'nodeId': 1923, 'name': 'FORD, RODNEY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2740, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 437 }, 'equipment': null, 'owner': null }, { 'nodeId': 1924, 'name': 'GILLIAM, JEFFREY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2740, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 438 }, 'equipment': null, 'owner': null }, { 'nodeId': 1925, 'name': 'JULIAN, JUSTIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2740, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 440 }, 'equipment': null, 'owner': null }, { 'nodeId': 1926, 'name': 'MONTGOMERY, BRAD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1061, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 470 }, 'equipment': null, 'owner': null }, { 'nodeId': 1927, 'name': 'MORGAN, JOEY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1061, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 474 }, 'equipment': null, 'owner': null }, { 'nodeId': 1928, 'name': 'REBSTOCK, MATTHEW', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2740, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 443 }, 'equipment': null, 'owner': null }, { 'nodeId': 1929, 'name': 'SCOTT, JOE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2740, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 445 }, 'equipment': null, 'owner': null }, { 'nodeId': 1930, 'name': 'WATKINS, JONATHAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2740, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 446 }, 'equipment': null, 'owner': null }, { 'nodeId': 1931, 'name': 'GODSEY, BRIAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2739, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 439 }, 'equipment': null, 'owner': null }, { 'nodeId': 1932, 'name': 'RHINE, JEFFREY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2741, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 444 }, 'equipment': null, 'owner': null }, { 'nodeId': 1933, 'name': 'WELLS, BRYANT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2741, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 447 }, 'equipment': null, 'owner': null }, { 'nodeId': 1934, 'name': 'PANNELLS, BRIAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1064, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 442 }, 'equipment': null, 'owner': null }, { 'nodeId': 1935, 'name': 'MAYS, BJ', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2742, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 459 }, 'equipment': null, 'owner': null }, { 'nodeId': 1936, 'name': 'ALLISON, JESSE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2745, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 449 }, 'equipment': null, 'owner': null }, { 'nodeId': 1937, 'name': 'AMERSON, JOEY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2745, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 450 }, 'equipment': null, 'owner': null }, { 'nodeId': 1938, 'name': 'CARTER, BRANDON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2745, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 452 }, 'equipment': null, 'owner': null }, { 'nodeId': 1939, 'name': 'CASSIDY, CHRIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2745, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 453 }, 'equipment': null, 'owner': null }, { 'nodeId': 1940, 'name': 'ELLIOTT, JUSTIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2745, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 454 }, 'equipment': null, 'owner': null }, { 'nodeId': 1941, 'name': 'JOHNSON, ISSAC', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2745, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 455 }, 'equipment': null, 'owner': null }, { 'nodeId': 1942, 'name': 'JONES, JULIUS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2745, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 456 }, 'equipment': null, 'owner': null }, { 'nodeId': 1943, 'name': 'MITCHELL, KYLE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2745, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.109Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.109Z', 'userAccount': { 'userAccountId': 460 }, 'equipment': null, 'owner': null }, { 'nodeId': 1944, 'name': 'OLIVARES, JOSE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2745, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 461 }, 'equipment': null, 'owner': null }, { 'nodeId': 1945, 'name': 'PRIMAS, CHANCY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2745, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 462 }, 'equipment': null, 'owner': null }, { 'nodeId': 1946, 'name': 'SHELTON, JOSH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2745, 'rank': 11, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 463 }, 'equipment': null, 'owner': null }, { 'nodeId': 1947, 'name': 'YOUNG, JERROD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2745, 'rank': 12, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 464 }, 'equipment': null, 'owner': null }, { 'nodeId': 1948, 'name': 'DACUS, CHRIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2739, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 436 }, 'equipment': null, 'owner': null }, { 'nodeId': 1949, 'name': 'LACKEY, DANNY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2744, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 457 }, 'equipment': null, 'owner': null }, { 'nodeId': 1950, 'name': 'LANGSTON, JEFFREY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1069, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 458 }, 'equipment': null, 'owner': null }, { 'nodeId': 1951, 'name': 'BURNETT, HERBERT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2746, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 465 }, 'equipment': null, 'owner': null }, { 'nodeId': 1952, 'name': 'HERRON, SCOTT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1071, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 466 }, 'equipment': null, 'owner': null }, { 'nodeId': 1953, 'name': 'MILLER, LESLIE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1072, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 468 }, 'equipment': null, 'owner': null }, { 'nodeId': 1954, 'name': 'DANIELS, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2748, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 467 }, 'equipment': null, 'owner': null }, { 'nodeId': 1955, 'name': 'BARGER, EDDY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2718, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 360 }, 'equipment': null, 'owner': null }, { 'nodeId': 1956, 'name': 'MOODY, SHANNON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1075, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 477 }, 'equipment': null, 'owner': null }, { 'nodeId': 1957, 'name': 'NOKES, TIM', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1075, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 478 }, 'equipment': null, 'owner': null }, { 'nodeId': 1958, 'name': 'SLABAUGH, BOBBY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1075, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 479 }, 'equipment': null, 'owner': null }, { 'nodeId': 1959, 'name': 'STRAUBINGER, ROGER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1075, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 480 }, 'equipment': null, 'owner': null }, { 'nodeId': 1960, 'name': 'COOK, SCOTT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1076, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 492 }, 'equipment': null, 'owner': null }, { 'nodeId': 1961, 'name': 'JARRETT, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1076, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 493 }, 'equipment': null, 'owner': null }, { 'nodeId': 1962, 'name': 'JONES, JOEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1076, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 494 }, 'equipment': null, 'owner': null }, { 'nodeId': 1963, 'name': 'MARTIN, GLENN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1076, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 495 }, 'equipment': null, 'owner': null }, { 'nodeId': 1964, 'name': 'PANKEY, MARTIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2753, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 487 }, 'equipment': null, 'owner': null }, { 'nodeId': 1965, 'name': 'QUEARRY, DAVID', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2754, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 488 }, 'equipment': null, 'owner': null }, { 'nodeId': 1966, 'name': 'RINEHART, RUSS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2754, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 489 }, 'equipment': null, 'owner': null }, { 'nodeId': 1967, 'name': 'SELLARS, BOBBY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2754, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 490 }, 'equipment': null, 'owner': null }, { 'nodeId': 1968, 'name': 'WILLIAMS, DANNY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2754, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 491 }, 'equipment': null, 'owner': null }, { 'nodeId': 1969, 'name': 'HILL, JAMES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1077, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 486 }, 'equipment': null, 'owner': null }, { 'nodeId': 1970, 'name': 'MOORE, JUSTIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1077, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 496 }, 'equipment': null, 'owner': null }, { 'nodeId': 1971, 'name': 'BALL, CHARLES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2775, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 658 }, 'equipment': null, 'owner': null }, { 'nodeId': 1972, 'name': 'BENTLEY, APRIL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2771, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 659 }, 'equipment': null, 'owner': null }, { 'nodeId': 1973, 'name': 'BREES, LORI', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2776, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 660 }, 'equipment': null, 'owner': null }, { 'nodeId': 1974, 'name': 'BURNS, THOMAS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2770, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 661 }, 'equipment': null, 'owner': null }, { 'nodeId': 1975, 'name': 'MARTIN, TAMRA', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2777, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 662 }, 'equipment': null, 'owner': null }, { 'nodeId': 1976, 'name': 'MCDAY, GLENN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2769, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 663 }, 'equipment': null, 'owner': null }, { 'nodeId': 1977, 'name': 'WOOLSEY, SHANNON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2774, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 666 }, 'equipment': null, 'owner': null }, { 'nodeId': 1978, 'name': 'CAUDLE, CINDY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1080, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 677 }, 'equipment': null, 'owner': null }, { 'nodeId': 1979, 'name': 'COLE, KEITH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1080, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 678 }, 'equipment': null, 'owner': null }, { 'nodeId': 1980, 'name': 'GARRETT, LEIGH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1080, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 679 }, 'equipment': null, 'owner': null }, { 'nodeId': 1981, 'name': 'GILMORE, WILLIE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1080, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 680 }, 'equipment': null, 'owner': null }, { 'nodeId': 1982, 'name': 'MCDAY, KELLY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1080, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 681 }, 'equipment': null, 'owner': null }, { 'nodeId': 1983, 'name': 'NASH, KENNETH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1080, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 682 }, 'equipment': null, 'owner': null }, { 'nodeId': 1984, 'name': 'PAYNE, BRAD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2772, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 664 }, 'equipment': null, 'owner': null }, { 'nodeId': 1985, 'name': 'WILLIAMS, DARYL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2799, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 1028 }, 'equipment': null, 'owner': null }, { 'nodeId': 1986, 'name': 'BLOUNT, DAVID', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1083, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.110Z', 'userAccount': { 'userAccountId': 472 }, 'equipment': null, 'owner': null }, { 'nodeId': 1987, 'name': 'HAUPTMAN, JEREMY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2800, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1022 }, 'equipment': null, 'owner': null }, { 'nodeId': 1988, 'name': 'DAVIS, CASEY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2799, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1021 }, 'equipment': null, 'owner': null }, { 'nodeId': 1989, 'name': 'JONES, TRENN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1085, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1024 }, 'equipment': null, 'owner': null }, { 'nodeId': 1990, 'name': 'MCADORY, ERIC', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1085, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1026 }, 'equipment': null, 'owner': null }, { 'nodeId': 1991, 'name': 'HAWKINS, JOSHUA', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2800, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1023 }, 'equipment': null, 'owner': null }, { 'nodeId': 1992, 'name': 'WARHURST, TYLER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2800, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1027 }, 'equipment': null, 'owner': null }, { 'nodeId': 1993, 'name': 'KENNON, GENE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1087, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1025 }, 'equipment': null, 'owner': null }, { 'nodeId': 1994, 'name': 'ROBERTSON, JEFF', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2801, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1032 }, 'equipment': null, 'owner': null }, { 'nodeId': 1995, 'name': 'JACKSON, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2802, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1029 }, 'equipment': null, 'owner': null }, { 'nodeId': 1996, 'name': 'RISTON, DANIEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2802, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1031 }, 'equipment': null, 'owner': null }, { 'nodeId': 1997, 'name': 'SMITH, CLINT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1091, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1033 }, 'equipment': null, 'owner': null }, { 'nodeId': 1998, 'name': 'STONE, DENNIS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2803, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1034 }, 'equipment': null, 'owner': null }, { 'nodeId': 1999, 'name': 'TRAPP, CHRISTOPHER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1091, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1035 }, 'equipment': null, 'owner': null }, { 'nodeId': 2000, 'name': 'WARD, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2803, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1036 }, 'equipment': null, 'owner': null }, { 'nodeId': 2001, 'name': 'LAWRENCE, ROBERT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1092, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1030 }, 'equipment': null, 'owner': null }, { 'nodeId': 2002, 'name': 'REDDEN, MATTHEW', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2804, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1043 }, 'equipment': null, 'owner': null }, { 'nodeId': 2003, 'name': 'ARRIOLA, MICHAEL', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1095, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1037 }, 'equipment': null, 'owner': null }, { 'nodeId': 2004, 'name': 'ENGLE, JOSHUA', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1095, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 469 }, 'equipment': null, 'owner': null }, { 'nodeId': 2005, 'name': 'FLIPPO, THOMAS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1095, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1039 }, 'equipment': null, 'owner': null }, { 'nodeId': 2006, 'name': 'FLOWERS, MARK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1095, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1040 }, 'equipment': null, 'owner': null }, { 'nodeId': 2007, 'name': 'HOPKINS, CHASE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1095, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1041 }, 'equipment': null, 'owner': null }, { 'nodeId': 2008, 'name': 'JOHNSON, CEDRIC', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1095, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1042 }, 'equipment': null, 'owner': null }, { 'nodeId': 2009, 'name': 'BEECHAM, DERRICK', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2805, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1038 }, 'equipment': null, 'owner': null }, { 'nodeId': 2010, 'name': 'WILLIAMS, KENT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1097, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1044 }, 'equipment': null, 'owner': null }, { 'nodeId': 2011, 'name': 'MORPHIS, GARRETT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2806, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1048 }, 'equipment': null, 'owner': null }, { 'nodeId': 2012, 'name': 'TIFFANY, LEE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2807, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1051 }, 'equipment': null, 'owner': null }, { 'nodeId': 2013, 'name': 'WHITE, DEAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2807, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1052 }, 'equipment': null, 'owner': null }, { 'nodeId': 2014, 'name': 'FINCHER, JAMES TYLER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1102, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1045 }, 'equipment': null, 'owner': null }, { 'nodeId': 2015, 'name': 'IBANEZ, ISAAC', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1102, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1047 }, 'equipment': null, 'owner': null }, { 'nodeId': 2016, 'name': 'PARKER, VINCENT', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2808, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1049 }, 'equipment': null, 'owner': null }, { 'nodeId': 2017, 'name': 'POWELL, JEREMY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2808, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1050 }, 'equipment': null, 'owner': null }, { 'nodeId': 2018, 'name': 'HASTINGS, DAVID', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1105, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 1046 }, 'equipment': null, 'owner': null }, { 'nodeId': 2019, 'name': 'JENKINS, NORMAN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2747, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 476 }, 'equipment': null, 'owner': null }, { 'nodeId': 2020, 'name': 'FOLEY, JERRY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 160, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 898 }, 'equipment': null, 'owner': null }, { 'nodeId': 2021, 'name': 'CLANTON, KYLEE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1108, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 719 }, 'equipment': null, 'owner': null }, { 'nodeId': 2022, 'name': 'WOODS, ASHLEY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2760, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 562 }, 'equipment': null, 'owner': null }, { 'nodeId': 2023, 'name': 'DUGAN, MIKE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1112, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 250 }, 'equipment': null, 'owner': null }, { 'nodeId': 2024, 'name': 'HAWKINS, MARTIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1113, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 538 }, 'equipment': null, 'owner': null }, { 'nodeId': 2025, 'name': 'HELFER, KYLE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2796, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 971 }, 'equipment': null, 'owner': null }, { 'nodeId': 2026, 'name': 'MCCAULEY, JON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1116, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-08-10T18:18:32.111Z', 'modifiedBy': -100, 'modifiedDate': '2016-08-10T18:18:32.111Z', 'userAccount': { 'userAccountId': 129 }, 'equipment': null, 'owner': null }, { 'nodeId': 2682, 'name': 'Administrator, System', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 1, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-09-06T20:44:37.324Z', 'modifiedBy': 1, 'modifiedDate': '2016-09-06T20:44:37.324Z', 'userAccount': { 'userAccountId': 1 }, 'equipment': null, 'owner': null }, { 'nodeId': 2683, 'name': 'EAF Helper/Ground', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 27, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.426Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.426Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2684, 'name': 'Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 28, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.436Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.436Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2685, 'name': 'EAF Helper/Ground', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 28, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.443Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.443Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2686, 'name': 'EAF Helper/Ground', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 29, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.521Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.521Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2687, 'name': 'Temp Melting Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 28, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.520Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.520Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2688, 'name': 'Alloy Refractory Handler', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 26, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.582Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.582Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2689, 'name': 'Temp Melting Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 29, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.581Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.581Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2690, 'name': 'EAF Helper/Ground', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 30, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.582Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.582Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2691, 'name': 'Bricker', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 26, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.635Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.635Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2692, 'name': 'Melt Shop Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 26, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.635Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.635Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2693, 'name': 'Regulations Specialist', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 26, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.696Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.696Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2694, 'name': 'Refractory Leadperson', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 26, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.696Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.696Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2695, 'name': 'Ladle Person Assistant', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 32, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.697Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.697Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2696, 'name': 'Ladle Person Assistant', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 33, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.724Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.724Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2697, 'name': 'Ladle Person Assistant', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 35, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.773Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.773Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2698, 'name': 'Furnace Analytical', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 31, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.775Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.775Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2699, 'name': 'Ladle Person Assistant', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 34, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.775Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.775Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2700, 'name': 'Casting Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 31, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.780Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.780Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2701, 'name': 'Melting Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 31, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.824Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.824Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2702, 'name': 'Scrap Yard Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 31, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.842Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.842Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2703, 'name': 'Roll Shop Lead Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 50, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.875Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.875Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2704, 'name': 'Crane 10 Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 51, 'rank': 14, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.875Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.875Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2705, 'name': 'Roll Mill Programmer Tech', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 50, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.875Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.875Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2706, 'name': 'Crane 11 Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 51, 'rank': 14, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.883Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.883Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2707, 'name': 'Crane 10 Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 52, 'rank': 14, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.940Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.940Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2708, 'name': 'Crane 11 Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 52, 'rank': 14, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.944Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.944Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2709, 'name': 'Crane 10 Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 53, 'rank': 14, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.953Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.953Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2710, 'name': 'Inspection Bed Inspector', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 53, 'rank': 15, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.989Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.989Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2711, 'name': 'Crane 11 Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 53, 'rank': 15, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:22.989Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:22.989Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2712, 'name': 'Crane 10 Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 54, 'rank': 14, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.006Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.006Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2713, 'name': 'CS Recorder', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 54, 'rank': 15, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.043Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.043Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2714, 'name': 'Crane 11 Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 54, 'rank': 15, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.046Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.046Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2715, 'name': 'Asst. Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 66, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.048Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.048Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2716, 'name': 'Shipper Loader Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 66, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.051Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.051Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2717, 'name': 'Shipper Loader Shuttle Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 66, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.103Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.103Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2718, 'name': 'Shipper Loader Trailer Repair', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 66, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.110Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.110Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2719, 'name': 'Asst. Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 67, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.123Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.123Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2720, 'name': 'Asst. Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 68, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.156Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.156Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2721, 'name': 'Shipper Loader Shuttle Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 67, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.156Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.156Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2722, 'name': 'Shipper Loader Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 68, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.159Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.159Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2723, 'name': 'Shipper Loader Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 67, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.159Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.159Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2724, 'name': 'Shipper Loader Shuttle Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 68, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.210Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.210Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2725, 'name': 'Asst. Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 69, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.222Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.222Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2726, 'name': 'Shipper Loader Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 69, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.222Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.222Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2727, 'name': 'Shipper Loader Shuttle Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 69, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.228Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.228Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2728, 'name': 'Asst. Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 70, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.270Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.270Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2729, 'name': 'Shipper Loader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 70, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.270Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.270Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2730, 'name': 'Shipper Loader Hem Saw-Random', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 70, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.276Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.276Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2731, 'name': 'Shipper Loader Shuttle Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 70, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.289Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.289Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2732, 'name': 'Shipper Loader Taylor Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 70, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.330Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.330Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2733, 'name': 'Asst. Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 71, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.338Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.338Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2734, 'name': 'Shipper Loader Hem Saw-Random', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 71, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.338Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.338Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2735, 'name': 'Shipper Loader Shuttle Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 71, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.338Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.338Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2736, 'name': 'Shipper Loader Taylor Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 71, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.381Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.381Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2737, 'name': 'Asst. Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 72, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.396Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.396Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2738, 'name': 'Shipper Loader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 72, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.398Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.398Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2739, 'name': 'Shipper Loader Hem Saw-Random', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 72, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.436Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.436Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2740, 'name': 'Shipper Loader Taylor Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 72, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.438Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.438Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2741, 'name': 'Shipper Loader Shuttle Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 72, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.438Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.438Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2742, 'name': 'Asst. Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 73, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.486Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.486Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2743, 'name': 'Shipper Loader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 73, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.485Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.485Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2744, 'name': 'Shipper Loader Shuttle Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 73, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.502Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.502Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2745, 'name': 'Shipper Loader Taylor Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 73, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.504Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.504Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2746, 'name': 'Asst. Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 74, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.544Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.544Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2747, 'name': 'Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 76, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.547Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.547Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2748, 'name': 'Asst. Lead Mechanic', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 75, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.547Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.547Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2749, 'name': 'IT Special Projects', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 65, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.556Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.556Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2750, 'name': 'Shipping Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 65, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.600Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.600Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2751, 'name': 'Shipping Supervisor Mill II', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 65, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.608Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.608Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2752, 'name': 'Shipping Yard Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 65, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.641Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.641Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2753, 'name': 'Temp Locomotive Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 77, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.642Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.642Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2754, 'name': 'Locomotive Operators', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 77, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.645Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.645Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2755, 'name': 'Guide Maker', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 55, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.658Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.658Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2756, 'name': 'Roll Shopl Temp Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 57, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.692Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.692Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2757, 'name': 'Roll Guide Builder', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 58, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.694Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.694Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2758, 'name': 'Roll Mill Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 58, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.694Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.694Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2759, 'name': 'Temp Roll Shop Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 58, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.742Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.742Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2760, 'name': 'Roll Designer', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 59, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.747Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.747Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2761, 'name': 'Finance Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 968, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.783Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.783Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2762, 'name': 'Finance Clerk', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 968, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.787Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.787Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2763, 'name': 'Finance Clerk', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 969, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.787Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.787Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2764, 'name': 'Sales and Project Pricing Rep', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 293, 'rank': 8, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.797Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.797Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2765, 'name': 'Sales Cooridinator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 295, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.841Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.841Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2766, 'name': 'Sales Rep', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 293, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.846Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.846Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2767, 'name': 'Plant Metallurgist', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 88, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.857Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.857Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2768, 'name': 'QMS Coordinator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 88, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.863Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.863Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2769, 'name': 'BRT Analyst', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 78, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.900Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.900Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2770, 'name': 'Barge Coodinator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 78, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.903Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.903Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2771, 'name': 'Equipment Training Coor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 78, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.906Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.906Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2772, 'name': 'Rail Barge Coordinator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 78, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.909Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.909Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2773, 'name': 'Rail Clerk', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 78, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.952Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.952Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2774, 'name': 'Shipping Administrator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 78, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.956Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.956Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2775, 'name': 'Traffic  Freight Analyst', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 78, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.964Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.964Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2776, 'name': 'Traffic Clerk', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 78, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:23.965Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:23.965Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2777, 'name': 'Truck Coordinator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 78, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.006Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.006Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2778, 'name': 'IT Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 970, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.008Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.008Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2779, 'name': 'Systems Engineer', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 970, 'rank': 3, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.011Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.011Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2780, 'name': 'Occupational Health Coor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 974, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.055Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.055Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2781, 'name': 'Construction Coordinator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 11, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.055Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.055Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2782, 'name': 'Safety Coor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 974, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.060Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.060Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2783, 'name': 'Lubricator Coordinator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 16, 'rank': 9, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.071Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.071Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2784, 'name': 'Lubricator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 18, 'rank': 5, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.113Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.113Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2785, 'name': 'Electrician', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 17, 'rank': 4, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.117Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.117Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2786, 'name': 'Maintenance Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 20, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.116Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.116Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2787, 'name': 'Electrical Apprentice', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 21, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.126Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.126Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2788, 'name': 'Mechanical Apprentice', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 23, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.167Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.167Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2789, 'name': 'Ladle Person Assistant', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 41, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.170Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.170Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2790, 'name': '#101 Overhead Crane', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 42, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.177Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.177Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2791, 'name': 'Temp Caster Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 42, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.184Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.184Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2792, 'name': 'Ladle Person Assistant', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 43, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.222Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.222Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2793, 'name': '#101 Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 43, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.224Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.224Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2794, 'name': 'Ladle Person Assistant', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 44, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.228Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.228Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2795, 'name': 'C Bed Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 61, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.276Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.276Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2796, 'name': 'Roll Mill Utility Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 61, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.276Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.276Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2797, 'name': 'Temp Caster Supervisor', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 44, 'rank': 11, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.276Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.276Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2798, 'name': 'Temp Lead Person', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 63, 'rank': 12, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.298Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.298Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2799, 'name': 'Shipper Loader Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 80, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.331Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.331Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2800, 'name': 'Shipper Loader Shuttle Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 80, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.334Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.334Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2801, 'name': 'Asst. Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 81, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.337Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.337Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2802, 'name': 'Shipper Loader Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 81, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.338Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.338Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2803, 'name': 'Shipper Loader Shuttle Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 81, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.384Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.384Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2804, 'name': 'Shipper Loader Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 82, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.392Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.392Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2805, 'name': 'Shipper Loader Shuttle Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 82, 'rank': 6, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.398Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.398Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2806, 'name': 'Asst. Crew Leader', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 83, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.431Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.431Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2807, 'name': 'Shipper Loader Crane Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 83, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.433Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.433Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2808, 'name': 'Shipper Loader Shuttle Operator', 'nodeDetailTypeId': 1, 'nodeTypeId': 4, 'treeId': 1, 'parent': 83, 'rank': 7, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:01:24.435Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:01:24.435Z', 'userAccount': null, 'equipment': null, 'owner': null }, { 'nodeId': 2809, 'name': 'SCHREMMER, VERNON', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2755, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:06:41.516Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:06:41.516Z', 'userAccount': { 'userAccountId': 509 }, 'equipment': null, 'owner': null }, { 'nodeId': 2810, 'name': 'LYNN, TIMOTHY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2798, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:06:41.838Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:06:41.838Z', 'userAccount': { 'userAccountId': 1010 }, 'equipment': null, 'owner': null }, { 'nodeId': 2811, 'name': 'JONES, RICKY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2759, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:06:42.366Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:06:42.366Z', 'userAccount': { 'userAccountId': 540 }, 'equipment': null, 'owner': null }, { 'nodeId': 2812, 'name': 'AUSTIN, KEVIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2755, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:06:43.310Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:06:43.310Z', 'userAccount': { 'userAccountId': 504 }, 'equipment': null, 'owner': null }, { 'nodeId': 2813, 'name': 'VERNON, M SHANE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2767, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:06:46.855Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:06:46.855Z', 'userAccount': { 'userAccountId': 638 }, 'equipment': null, 'owner': null }, { 'nodeId': 2814, 'name': 'FOWLER, WESLEY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2685, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:06:47.767Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:06:47.767Z', 'userAccount': { 'userAccountId': 148 }, 'equipment': null, 'owner': null }, { 'nodeId': 2815, 'name': 'BROWN, RAY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2691, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:06:48.299Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:06:48.299Z', 'userAccount': { 'userAccountId': 180 }, 'equipment': null, 'owner': null }, { 'nodeId': 2816, 'name': 'QUINTANILLA, OMAR', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2693, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:06:48.391Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:06:48.391Z', 'userAccount': { 'userAccountId': 185 }, 'equipment': null, 'owner': null }, { 'nodeId': 2817, 'name': 'BUCHANAN, MARTIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2790, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:06:48.780Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:06:48.780Z', 'userAccount': { 'userAccountId': 918 }, 'equipment': null, 'owner': null }, { 'nodeId': 2818, 'name': 'WILKERSON, JOHNNY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2794, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:06:49.097Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:06:49.097Z', 'userAccount': { 'userAccountId': 952 }, 'equipment': null, 'owner': null }, { 'nodeId': 2819, 'name': 'JOHNSON, JOHN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2689, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:06:49.208Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:06:49.208Z', 'userAccount': { 'userAccountId': 164 }, 'equipment': null, 'owner': null }, { 'nodeId': 2820, 'name': 'LOMAX, JOHN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2687, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:06:49.211Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:06:49.211Z', 'userAccount': { 'userAccountId': 150 }, 'equipment': null, 'owner': null }, { 'nodeId': 2821, 'name': 'GARNER, JESS', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2692, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:06:49.352Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:06:49.352Z', 'userAccount': { 'userAccountId': 183 }, 'equipment': null, 'owner': null }, { 'nodeId': 2822, 'name': 'KELLEY, HOWARD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2700, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:06:49.721Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:06:49.721Z', 'userAccount': { 'userAccountId': 245 }, 'equipment': null, 'owner': null }, { 'nodeId': 2823, 'name': 'MATHIS, GREG', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2701, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:06:49.835Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:06:49.835Z', 'userAccount': { 'userAccountId': 246 }, 'equipment': null, 'owner': null }, { 'nodeId': 2824, 'name': 'BRYANT, CHRISTOPHER', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2789, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:06:50.436Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:06:50.436Z', 'userAccount': { 'userAccountId': 905 }, 'equipment': null, 'owner': null }, { 'nodeId': 2825, 'name': 'CLARK, CHARLES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2701, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:06:50.539Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:06:50.539Z', 'userAccount': { 'userAccountId': 244 }, 'equipment': null, 'owner': null }, { 'nodeId': 2826, 'name': 'JONES, CHARLES', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2793, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:06:50.915Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:06:50.915Z', 'userAccount': { 'userAccountId': 937 }, 'equipment': null, 'owner': null }, { 'nodeId': 2827, 'name': 'WILLIAMS, AMY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2684, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:06:51.016Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:06:51.016Z', 'userAccount': { 'userAccountId': 156 }, 'equipment': null, 'owner': null }, { 'nodeId': 2828, 'name': 'OSMER, TIM', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2784, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:06:52.070Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:06:52.070Z', 'userAccount': { 'userAccountId': 819 }, 'equipment': null, 'owner': null }, { 'nodeId': 2829, 'name': 'GIFFORD, SARAH', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2761, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:06:57.819Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:06:57.819Z', 'userAccount': { 'userAccountId': 571 }, 'equipment': null, 'owner': null }, { 'nodeId': 2830, 'name': 'ROGERS, TONY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2773, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:06:59.348Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:06:59.348Z', 'userAccount': { 'userAccountId': 665 }, 'equipment': null, 'owner': null }, { 'nodeId': 2831, 'name': 'RAY, KEVIN', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2749, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:07:00.478Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:07:00.478Z', 'userAccount': { 'userAccountId': 484 }, 'equipment': null, 'owner': null }, { 'nodeId': 2832, 'name': 'MARSHALL, DONALD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2738, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:07:01.661Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:07:01.661Z', 'userAccount': { 'userAccountId': 441 }, 'equipment': null, 'owner': null }, { 'nodeId': 2833, 'name': 'WHEELER, CORY', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2740, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:07:02.043Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:07:02.043Z', 'userAccount': { 'userAccountId': 448 }, 'equipment': null, 'owner': null }, { 'nodeId': 2834, 'name': 'BROWN, BRUCE', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2743, 'rank': 1, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:07:02.362Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:07:02.362Z', 'userAccount': { 'userAccountId': 451 }, 'equipment': null, 'owner': null }, { 'nodeId': 2835, 'name': 'EUBANKS, BRAD', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 2754, 'rank': 10, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': -100, 'createdDate': '2016-09-20T22:07:02.548Z', 'modifiedBy': -100, 'modifiedDate': '2016-09-20T22:07:02.548Z', 'userAccount': { 'userAccountId': 485 }, 'equipment': null, 'owner': null }, { 'nodeId': 2836, 'name': 'ELECTRON MICROSCOPE, ', 'nodeDetailTypeId': 2, 'nodeTypeId': 0, 'treeId': 1, 'parent': 977, 'rank': 2, 'ownerNodeId': null, 'isDeleted': false, 'createdBy': 1, 'createdDate': '2016-10-13T19:09:30.550Z', 'modifiedBy': 1, 'modifiedDate': '2016-10-13T19:09:30.550Z', 'userAccount': { 'userAccountId': 1316 }, 'equipment': null, 'owner': null }]

function toggleNodeOpen (id, localNodes = nodes) {
  for (var i = 0; i < localNodes.length; i++) {
    if (localNodes[i].id === id) {
      localNodes[i].open = !localNodes[i].open
    } else {
      if (localNodes[i].children !== undefined) {
        toggleNodeOpen(id, localNodes[i].children)
      }
    }
  }
}

function setNodeActive (id, localNodes = nodes) {
  for (var i = 0; i < localNodes.length; i++) {
    if (localNodes[i].id === id) {
      localNodes[i].active = true
    } else {
      localNodes[i].active = false
    }
    if (localNodes[i].children !== undefined) {
      setNodeActive(id, localNodes[i].children)
    }
  }
}

const Example = React.createClass({

  render () {
    const header = <Label><input ref='filter' onChange={(e) => { this.refs.exampleTree.setFilter(this.refs.filter.value) }} type='text' /></Label>
    return <div style={{ 'maxWidth': '300px' }}><Tree ref='exampleTree' nodes={nodes}
      header={header}
      isEditable
      titlePropertyPath='name'
      onNodeClick={(node) => {
        setNodeActive(node.id)
        this.forceUpdate()
      }}
      onToggleClick={(node) => {
        toggleNodeOpen(node.id)
        this.forceUpdate()
      }} /></div>
  }
})

export default Example
